package demo.barcharts.category ;

import java.awt.BasicStroke ;
import java.awt.Color ;
import java.awt.GradientPaint ;
import java.awt.GridLayout ;
import java.awt.Paint ;

import javax.swing.JPanel ;

import com.ijchart.xychart.axis.category.CategoryAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.AxisLabelType ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.constant.GradientPaintTransformType ;
import com.ijchart.xychart.constant.HorizontalAlignment ;
import com.ijchart.xychart.data.NumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.plot.CategoryPlot ;
import com.ijchart.xychart.render.category.Bar2DRender ;
import com.ijchart.xychart.title.TextTitle ;
import com.ijchart.xychart.ui.RectangleInsets ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class BarChartDemo9 extends JPanel {
  private ChartOrientation orientation = ChartOrientation.VERTICAL ;

  public BarChartDemo9() {
    setLayout(new GridLayout(1, 1)) ;
    addPanel() ;
  }

  private void addPanel() {
    final IMatrixDataset dataset = createDataset() ;
    final IJChart chart = ChartFactory.createCategoryBar2DChart(
      "Bar Chart Demo 9", null, "Value", dataset, orientation, false, true) ;

    CategoryPlot plot = (CategoryPlot) chart.getPlot() ;

    TextTitle texttitle = (TextTitle) chart.getTitle() ;
    texttitle.setBackgroundPaint(new GradientPaint(0.0F, 0.0F, Color.red, 350F, 0.0F, Color.white, true)) ;
    texttitle.setFillBackground(true) ;
    texttitle.setExpandToFitSpace(true) ;
    texttitle.setHorizontalAlignment(HorizontalAlignment.CENTER) ;

    CategoryAxis categoryaxis = plot.getCategoryAxis() ;
    categoryaxis.setAxisLabelType(AxisLabelType.COLUMN) ;

    chart.setBackgroundPaint(new GradientPaint(0.0F, 0.0F, Color.white, 350F, 0.0F, Color.yellow, true)) ;
    chart.setGradientPaintTransformType(GradientPaintTransformType.CENTER_HORIZONTAL) ;
    plot.setBackgroundPaint(null) ;
    plot.getRender().setBackgroundPaint(null) ;

    plot.setInsets(new RectangleInsets(10D, 5D, 5D, 5D)) ;
    plot.setBorderPaint(Color.black) ;
    plot.setValueGridlineStroke(new BasicStroke()) ;
    plot.setValueGridlinePaint(Color.gray) ;
    plot.setDomainGridlineVisible(false);

    Paint paints[] = createPaint() ;
    Bar2DRender render = (Bar2DRender) plot.getRender() ;
    render.setAutoSelectFillPaint(false) ;
    for (int i = 0 ; i < 5 ; i++) {
      render.setColumnItemFillPaint(i, paints[i]) ;
      render.setBaseItemDrawBorder(true) ;
      render.setColumnItemFillPaintTransformer(i, GradientPaintTransformType.CENTER_HORIZONTAL) ;
    }

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static Paint[] createPaint() {
    Paint apaint[] = new Paint[5] ;
    apaint[0] = new GradientPaint(0.0F, 0.0F, Color.red, 0.0F, 0.0F, Color.white) ;
    apaint[1] = new GradientPaint(0.0F, 0.0F, Color.green, 0.0F, 0.0F, Color.white) ;
    apaint[2] = new GradientPaint(0.0F, 0.0F, Color.blue, 0.0F, 0.0F, Color.white) ;
    apaint[3] = new GradientPaint(0.0F, 0.0F, Color.orange, 0.0F, 0.0F, Color.white) ;
    apaint[4] = new GradientPaint(0.0F, 0.0F, Color.magenta, 0.0F, 0.0F, Color.white) ;
    return apaint ;
  }

  private static IMatrixDataset createDataset() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;

    dataset.addColKey("Monday") ;
    dataset.addColKey("Tuesday") ;
    dataset.addColKey("Wednesday") ;
    dataset.addColKey("Thursday") ;
    dataset.addColKey("Friday") ;

    double data[] = {410D, 680D, 530D, 570D, 330D} ;
    dataset.addRowData() ;

    for (int j = 0 ; j < data.length ; j++) {
      dataset.addData(0, new NumberChartData(data[j])) ;
    }

    return dataset ;
  }

}
