package demo.miscellaneous ;

import java.awt.BorderLayout ;
import java.awt.event.ActionEvent ;
import java.awt.event.ActionListener ;

import javax.swing.ButtonGroup ;
import javax.swing.JCheckBox ;
import javax.swing.JPanel ;
import javax.swing.JRadioButton ;
import javax.swing.JSlider ;
import javax.swing.border.TitledBorder ;
import javax.swing.event.ChangeEvent ;
import javax.swing.event.ChangeListener ;

import com.ijchart.xychart.axis.category.CategoryAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.data.NumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.plot.CategoryPlot ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class CategoryLabelPositionsDemo1 extends JPanel {
  private ChartOrientation orientation = ChartOrientation.VERTICAL ;

  private JCheckBox invertCheckBox ;

  private JRadioButton horizontalRadioButton ;

  private JRadioButton verticalRadioButton ;

  private JSlider slider ;

  public CategoryLabelPositionsDemo1() {
    setLayout(new BorderLayout()) ;
    addPanel() ;
  }

  private void addPanel() {
    final IJChart chart = createChart() ;

    JPanel jpanel = new JPanel(new BorderLayout()) ;
    JPanel jpanel1 = new JPanel(new BorderLayout()) ;
    JPanel jpanel2 = new JPanel() ;
    invertCheckBox = new JCheckBox("Invert Range Axis?") ;
    invertCheckBox.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent actionevent) {
        CategoryPlot categoryplot = (CategoryPlot) chart.getPlot() ;
        categoryplot.getValueAxis().setInverted(invertCheckBox.isSelected()) ;
      }
    }) ;
    jpanel2.add(invertCheckBox) ;
    ButtonGroup buttongroup = new ButtonGroup() ;
    horizontalRadioButton = new JRadioButton("Horizontal", false) ;
    horizontalRadioButton.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent actionevent) {
        if (horizontalRadioButton.isSelected()) {
          CategoryPlot categoryplot = (CategoryPlot) chart.getPlot() ;
          categoryplot.setOrientation(ChartOrientation.HORIZONTAL) ;
        }
      }

    }) ;
    buttongroup.add(horizontalRadioButton) ;
    verticalRadioButton = new JRadioButton("Vertical", true) ;
    verticalRadioButton.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent actionevent) {
        if (verticalRadioButton.isSelected()) {
          CategoryPlot categoryplot = (CategoryPlot) chart.getPlot() ;
          categoryplot.setOrientation(ChartOrientation.VERTICAL) ;
        }
      }
    }) ;

    buttongroup.add(verticalRadioButton) ;
    jpanel2.add(horizontalRadioButton) ;
    jpanel2.add(verticalRadioButton) ;
    jpanel2.setBorder(new TitledBorder("Plot Settings: ")) ;
    JPanel jpanel3 = new JPanel(new BorderLayout()) ;
    slider = new JSlider(0, 90, 45) ;
    slider.setMajorTickSpacing(10) ;
    slider.setMinorTickSpacing(5) ;
    slider.setPaintLabels(true) ;
    slider.setPaintTicks(true) ;
    slider.addChangeListener(new ChangeListener() {
      public void stateChanged(ChangeEvent changeevent) {
        CategoryPlot categoryplot = (CategoryPlot) chart.getPlot() ;
        CategoryAxis categoryaxis = categoryplot.getCategoryAxis() ;
        categoryaxis.setTickLabelAngle(slider.getValue() * Math.PI / 180D) ;
      }
    }) ;
    jpanel3.add(slider) ;
    jpanel3.setBorder(new TitledBorder("Axis Label Rotation Angle:")) ;
    jpanel1.add("North", jpanel2) ;
    jpanel1.add(jpanel3) ;
    jpanel.add(new ChartPanel(chart)) ;
    jpanel.add("South", jpanel1) ;

    add(jpanel) ;
  }

  private IJChart createChart() {
    IMatrixDataset dataset = createDataset() ;
    IJChart chart = ChartFactory.createCategoryBar2DChart("CategoryLabelPositionsDemo1", "Category",
                                                          "Value", dataset, orientation, false, false) ;
    CategoryPlot categoryplot = (CategoryPlot) chart.getPlot() ;
    CategoryAxis categoryaxis = categoryplot.getCategoryAxis() ;
    categoryaxis.setTickLabelAngle(-10 * Math.PI / 180D) ;

    return chart ;
  }

  private static IMatrixDataset createDataset() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addRowKey("Category 1 (Long)") ;
    dataset.addRowKey("Category 2 (Long)") ;
    dataset.addRowKey("Category 3 (Long)") ;
    dataset.addRowKey("Category 4 (Long)") ;
    dataset.addRowKey("Category 5 (Long)") ;
    dataset.addRowKey("Category 6 (Long)") ;
    dataset.addRowKey("Category 7 (Long)") ;
    dataset.addRowKey("Category 8 (Long)") ;
    dataset.addColKey("R1") ;

    dataset.addRowData(8) ;
    dataset.addData(0, new NumberChartData(1.0D)) ;
    dataset.addData(1, new NumberChartData(5D)) ;
    dataset.addData(2, new NumberChartData(3D)) ;
    dataset.addData(3, new NumberChartData(2D)) ;
    dataset.addData(4, new NumberChartData(9D)) ;
    dataset.addData(5, new NumberChartData(7D)) ;
    dataset.addData(6, new NumberChartData(6D)) ;
    dataset.addData(7, new NumberChartData(8D)) ;

    return dataset ;
  }

}
