package demo.miscellaneous ;

import java.awt.BasicStroke ;
import java.awt.BorderLayout ;
import java.awt.Color ;
import java.awt.Font ;
import java.awt.GradientPaint ;
import java.awt.GridLayout ;
import java.awt.Shape ;
import java.awt.geom.Ellipse2D ;
import java.awt.image.BufferedImage ;
import java.util.List ;
import java.util.Random ;

import javax.swing.ImageIcon ;
import javax.swing.JButton ;
import javax.swing.JPanel ;

import com.ijchart.xychart.axis.category.CategoryAxis ;
import com.ijchart.xychart.axis.value.IntervalXYValueAxis ;
import com.ijchart.xychart.axis.value.NumberValueAxis ;
import com.ijchart.xychart.axis.value.StackedNumberValueAxis ;
import com.ijchart.xychart.chartinfo.ChartShapeCollection ;
import com.ijchart.xychart.chartinfo.LegendShapeCollection ;
import com.ijchart.xychart.chartinfo.draw.ChangeChartShapeAdapter ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.constant.GradientPaintTransformType ;
import com.ijchart.xychart.constant.HistogramType ;
import com.ijchart.xychart.constant.HorizontalAlignment ;
import com.ijchart.xychart.constant.Rotation ;
import com.ijchart.xychart.data.IntervalXYNumberChartData ;
import com.ijchart.xychart.data.NumberChartData ;
import com.ijchart.xychart.data.YIntervalChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.dataset.SingleRowDataset ;
import com.ijchart.xychart.plot.CategoryPlot ;
import com.ijchart.xychart.plot.NoAxisPlot ;
import com.ijchart.xychart.plot.XYPlot ;
import com.ijchart.xychart.render.category.Bar2DRender ;
import com.ijchart.xychart.render.category.LineAndShapeRender ;
import com.ijchart.xychart.render.category.StackedBarRender ;
import com.ijchart.xychart.render.noaxis.PieRender ;
import com.ijchart.xychart.shape.IChartShape ;
import com.ijchart.xychart.tickunit.LongTickUnit ;
import com.ijchart.xychart.title.AbstractTitle ;
import com.ijchart.xychart.title.TextTitle ;
import com.ijchart.xychart.ui.RectangleEdge ;
import com.ijchart.xychart.ui.RectangleInsets ;
import com.ijchart.xychart.ui.supplier.DefaultDrawingSupplier ;
import com.ijchart.xychart.util.DatasetUtil ;
import com.ijchart.xychart.util.DateUtil ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class ThumbnailDemo1 extends JPanel {
  private ChartOrientation orientation = ChartOrientation.VERTICAL ;

  public ThumbnailDemo1() {
    setLayout(new BorderLayout()) ;
    createDemoPanel() ;
  }

  public void createDemoPanel() {
    setLayout(new GridLayout(2, 3)) ;

    IJChart chart1 = createChart1() ;
    BufferedImage bufferedimage1 = chart1.createBufferedImage(120, 80, 360D, 240D) ;
    ImageIcon imageicon1 = new ImageIcon(bufferedimage1) ;
    add(new JButton(imageicon1)) ;

    IJChart chart2 = createChart2() ;
    BufferedImage bufferedimage2 = chart2.createBufferedImage(120, 80, 360D, 240D) ;
    ImageIcon imageicon2 = new ImageIcon(bufferedimage2) ;
    add(new JButton(imageicon2)) ;

    IJChart chart3 = createChart3() ;
    BufferedImage bufferedimage3 = chart3.createBufferedImage(120, 80, 360D, 240D) ;
    ImageIcon imageicon3 = new ImageIcon(bufferedimage3) ;
    add(new JButton(imageicon3)) ;

    IJChart chart4 = createChart4() ;
    BufferedImage bufferedimage4 = chart4.createBufferedImage(120, 80, 360D, 240D) ;
    ImageIcon imageicon4 = new ImageIcon(bufferedimage4) ;
    add(new JButton(imageicon4)) ;

    IJChart chart5 = createChart5() ;
    BufferedImage image5 = chart5.createBufferedImage(120, 80, 360D, 240D) ;
    ImageIcon imageicon5 = new ImageIcon(image5) ;
    add(new JButton(imageicon5)) ;

    IJChart chart6 = createChart6() ;
    BufferedImage image6 = chart6.createBufferedImage(120, 80, 360D, 240D) ;
    ImageIcon imageicon6 = new ImageIcon(image6) ;
    add(new JButton(imageicon6)) ;
  }

  private static IMatrixDataset createDataset1() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addRowKey("Category 1") ;
    dataset.addRowKey("Category 2") ;
    dataset.addRowKey("Category 3") ;
    dataset.addRowKey("Category 4") ;
    dataset.addRowKey("Category 5") ;

    dataset.addColKey("First") ;
    dataset.addColKey("Second") ;
    dataset.addColKey("Third") ;

    double[][] data = { {1.0D, 5D, 4D}, {4D, 7D, 3D}, {3D, 6D, 2D}, {5D, 8D, 3D}, {5D, 4D, 6D}
    } ;
    dataset.addRowData(data.length) ;

    for (int i = 0 ; i < data.length ; i++) {
      for (int j = 0 ; j < 3 ; j++) {
        dataset.addData(i, new NumberChartData(data[i][j])) ;
      }
    }

    return dataset ;
  }

  private IJChart createChart1() {
    final IMatrixDataset dataset = createDataset1() ;
    final IJChart chart = ChartFactory.createCategoryBar2DChart(
      "Bar Chart Demo 1", "Category", "Value", dataset, orientation, true, true) ;

    CategoryPlot plot = (CategoryPlot) chart.getPlot() ;
    plot.setDomainGridlinePaint(Color.white) ;
    plot.setValueGridlinePaint(Color.white) ;
    plot.getRender().setBackgroundPaint(Color.lightGray) ;

    plot.setValueCrosshairVisible(true) ;
    plot.setValueCrosshairPaint(Color.blue) ;
    NumberValueAxis numberaxis = (NumberValueAxis) plot.getValueAxis() ;
    numberaxis.setTickUnit(new LongTickUnit()) ;

    Bar2DRender render = (Bar2DRender) plot.getRender() ;
    render.setBaseItemDrawBorder(false) ;
    GradientPaint gradientpaint = new GradientPaint(0.0F, 0.0F, Color.blue, 0.0F, 0.0F,
                                                    new Color(0, 0, 64)) ;
    GradientPaint gradientpaint1 = new GradientPaint(0.0F, 0.0F, Color.green, 0.0F, 0.0F,
                                                     new Color(0, 64, 0)) ;
    GradientPaint gradientpaint2 = new GradientPaint(0.0F, 0.0F, Color.red, 0.0F, 0.0F,
                                                     new Color(64, 0, 0)) ;
    render.setAutoSelectFillPaint(false) ;
    render.setBaseItemFillPaintTransformer(GradientPaintTransformType.HORIZONTAL) ;
    render.setColumnItemFillPaint(0, gradientpaint) ;
    render.setColumnItemFillPaint(1, gradientpaint1) ;
    render.setColumnItemFillPaint(2, gradientpaint2) ;

    CategoryAxis categoryaxis = plot.getCategoryAxis() ;
    categoryaxis.setTickLabelAngle( -0.52359877559829882D) ;

    chart.setChangeChartShape(new ChangeChartShapeAdapter() {
      public void beforeDraw(ChartShapeCollection chartShapes) {
        LegendShapeCollection legendShapes = chart.getChartShapes().getLegendShapes() ;
        List shapes = legendShapes.getLegendShapes() ;

        IChartShape shape = (IChartShape) shapes.get(0) ;
        shape.setTooltipText("Tooltip: " + dataset.getColKey(0)) ;
        shape = (IChartShape) shapes.get(1) ;
        shape.setTooltipText("Tooltip: " + dataset.getColKey(1)) ;
        shape = (IChartShape) shapes.get(2) ;
        shape.setTooltipText("Tooltip: " + dataset.getColKey(2)) ;
      }

    }) ;

    return chart ;
  }

  private static SingleRowDataset createDataset2() {
    SingleRowDataset dataset = new SingleRowDataset() ;

    dataset.addColKey("Java") ;
    dataset.addColKey("Visual Basic") ;
    dataset.addColKey("C/C++") ;
    dataset.addColKey("PHP") ;
    dataset.addColKey("Perl") ;

    dataset.addRowData() ;
    dataset.addData(0, new NumberChartData(43.200000000000003D)) ;
    dataset.addData(0, new NumberChartData(10D)) ;
    dataset.addData(0, new NumberChartData(17.5D)) ;
    dataset.addData(0, new NumberChartData(32.5D)) ;
    dataset.addData(0, null) ;

    return dataset ;
  }

  private static IJChart createChart2() {
    SingleRowDataset dataset = createDataset2() ;
    IJChart chart = ChartFactory.createPie3DChart("Pie Chart 3D Demo 1", dataset, true, true) ;
    NoAxisPlot plot = (NoAxisPlot) chart.getPlot() ;
    plot.setForegroundAlpha(0.5F) ;
    plot.setNoDataMessage("No data to display") ;

    PieRender render = (PieRender) plot.getRender() ;
    render.setStartAngle(290D) ;
    render.setCircular(true) ;
    render.setPieRotation(Rotation.CLOCKWISE) ;

    return chart ;
  }

  private static IMatrixDataset createDataset3() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addColKey("Against all torture") ;
    dataset.addColKey("") ;
    dataset.addColKey("Some degree permissible") ;

    dataset.addRowKey("Italy") ;
    dataset.addRowKey("Great Britain") ;
    dataset.addRowKey("USA") ;
    dataset.addRowKey("Israel") ;
    dataset.addRowKey("Russia") ;
    dataset.addRowKey("India") ;
    dataset.addRowKey("Average (*)") ;

    double data1[] = {81D, 72D, 58D, 48D, 43D, 23D, 59D} ;
    double data2[] = {5D, 4D, 6D, 9D, 20D, 45D, 12D} ;
    double data3[] = {14D, 24D, 36D, 43D, 37D, 32D, 29D} ;

    dataset.addRowData(data1.length) ;
    for (int i = 0 ; i < data1.length ; i++) {
      dataset.addData(i, new NumberChartData(data1[i])) ;
      dataset.addData(i, new NumberChartData(data2[i])) ;
      dataset.addData(i, new NumberChartData(data3[i])) ;
    }

    return dataset ;
  }

  private IJChart createChart3() {
    IMatrixDataset dataset = createDataset3() ;
    IJChart chart = ChartFactory.createStackedBarChart("Public Opinion : Torture of Prisoners",
                                                       "Country", "%", dataset, orientation, true, true) ;
    CategoryPlot plot = (CategoryPlot) chart.getPlot() ;

    ((AbstractTitle) chart.getTitle()).setPadding(new RectangleInsets(2D, 0.0D, 0.0D, 0.0D)) ;
    TextTitle texttitle = new TextTitle("Source: http://news.bbc.co.uk/1/hi/world/6063386.stm",
                                        new Font("Dialog", 0, 11)) ;
    texttitle.setPosition(RectangleEdge.BOTTOM) ;
    texttitle.setHorizontalAlignment(HorizontalAlignment.RIGHT) ;
    texttitle.setPadding(new RectangleInsets(0.0D, 0.0D, 4D, 4D)) ;
    chart.addSubtitle(texttitle) ;
    TextTitle texttitle1 = new TextTitle("(*) Across 27,000 respondents in 25 countries",
                                         new Font("Dialog", 0, 11)) ;
    texttitle1.setPosition(RectangleEdge.BOTTOM) ;
    texttitle1.setHorizontalAlignment(HorizontalAlignment.RIGHT) ;
    texttitle1.setPadding(new RectangleInsets(4D, 0.0D, 2D, 4D)) ;
    chart.addSubtitle(texttitle1) ;

    plot.setDomainGridlineVisible(true) ;
    StackedNumberValueAxis numberaxis = (StackedNumberValueAxis) plot.getValueAxis() ;
    numberaxis.setTickUnit(new LongTickUnit()) ;
    numberaxis.setUpperMargin(0.0D) ;

    StackedBarRender render = (StackedBarRender) plot.getRender() ;
    GradientPaint gradientpaint = new GradientPaint(0.0F, 0.0F, Color.green, 0.0F, 0.0F,
                                                    new Color(0, 64, 0)) ;
    Color color = new Color(0, 0, 0, 0) ;
    GradientPaint gradientpaint1 = new GradientPaint(0.0F, 0.0F, Color.red, 0.0F, 0.0F,
                                                     new Color(64, 0, 0)) ;
    render.setAutoSelectFillPaint(false) ;
    render.setColumnItemFillPaint(0, gradientpaint) ;
    render.setColumnItemFillPaint(1, color) ;
    render.setColumnItemFillPaint(2, gradientpaint1) ;

    return chart ;
  }

  private static IMatrixDataset createDataset4() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addColKey("Against all torture") ;
    dataset.addColKey("") ;
    dataset.addColKey("Some degree permissible") ;

    dataset.addRowKey("Italy") ;
    dataset.addRowKey("Great Britain") ;
    dataset.addRowKey("USA") ;
    dataset.addRowKey("Israel") ;
    dataset.addRowKey("Russia") ;
    dataset.addRowKey("India") ;
    dataset.addRowKey("Average (*)") ;

    double data1[] = {81D, 72D, 58D, 48D, 43D, 23D, 59D} ;
    double data2[] = {5D, 4D, 6D, 9D, 20D, 45D, 12D} ;
    double data3[] = {14D, 24D, 36D, 43D, 37D, 32D, 29D} ;

    dataset.addRowData(data1.length) ;
    for (int i = 0 ; i < data1.length ; i++) {
      dataset.addData(i, new NumberChartData(data1[i])) ;
      dataset.addData(i, new NumberChartData(data2[i])) ;
      dataset.addData(i, new NumberChartData(data3[i])) ;
    }

    return dataset ;
  }

  private static YIntervalChartData createData(int day, int month, int year,
                                               double y, double yLow, double yHigh) {
    return new YIntervalChartData(DateUtil.dateToTimeInMillis(year, month, day), y, yLow, yHigh) ;
  }

  private IJChart createChart4() {
    IMatrixDataset dataset = createDataset4() ;
    IJChart chart = ChartFactory.createStackedBarChart("Public Opinion : Torture of Prisoners",
                                                       "Country", "%", dataset, orientation, true, true) ;
    CategoryPlot plot = (CategoryPlot) chart.getPlot() ;

    ((AbstractTitle) chart.getTitle()).setPadding(new RectangleInsets(2D, 0.0D, 0.0D, 0.0D)) ;
    TextTitle texttitle = new TextTitle("Source: http://news.bbc.co.uk/1/hi/world/6063386.stm",
                                        new Font("Dialog", 0, 11)) ;
    texttitle.setPosition(RectangleEdge.BOTTOM) ;
    texttitle.setHorizontalAlignment(HorizontalAlignment.RIGHT) ;
    texttitle.setPadding(new RectangleInsets(0.0D, 0.0D, 4D, 4D)) ;
    chart.addSubtitle(texttitle) ;
    TextTitle texttitle1 = new TextTitle("(*) Across 27,000 respondents in 25 countries",
                                         new Font("Dialog", 0, 11)) ;
    texttitle1.setPosition(RectangleEdge.BOTTOM) ;
    texttitle1.setHorizontalAlignment(HorizontalAlignment.RIGHT) ;
    texttitle1.setPadding(new RectangleInsets(4D, 0.0D, 2D, 4D)) ;
    chart.addSubtitle(texttitle1) ;

    plot.setDomainGridlineVisible(true) ;
    StackedNumberValueAxis numberaxis = (StackedNumberValueAxis) plot.getValueAxis() ;
    numberaxis.setTickUnit(new LongTickUnit()) ;
    numberaxis.setUpperMargin(0.0D) ;

    StackedBarRender render = (StackedBarRender) plot.getRender() ;
    GradientPaint gradientpaint = new GradientPaint(0.0F, 0.0F, Color.green, 0.0F, 0.0F,
                                                    new Color(0, 64, 0)) ;
    Color color = new Color(0, 0, 0, 0) ;
    GradientPaint gradientpaint1 = new GradientPaint(0.0F, 0.0F, Color.red, 0.0F, 0.0F,
                                                     new Color(64, 0, 0)) ;
    render.setAutoSelectFillPaint(false) ;
    render.setColumnItemFillPaint(0, gradientpaint) ;
    render.setColumnItemFillPaint(1, color) ;
    render.setColumnItemFillPaint(2, gradientpaint1) ;

    return chart ;
  }

  private static DefaultMatrixDataset createDataset5() {
    double ad[] = new double[1000] ;
    Random random = new Random(0xbc614eL) ;
    for (int i = 0 ; i < 1000 ; i++) {
      ad[i] = random.nextGaussian() + 5D ;
    }

    IntervalXYNumberChartData[] datas = DatasetUtil.convertToHistogramData(ad, 100, 2D, 8D,
                                                                           HistogramType.FREQUENCY) ;
    ad = new double[1000] ;
    for (int j = 0 ; j < 1000 ; j++) {
      ad[j] = random.nextGaussian() + 7D ;
    }

    IntervalXYNumberChartData[] datas2 = DatasetUtil.convertToHistogramData(ad, 100, 4D, 10D,
                                                                            HistogramType.FREQUENCY) ;

    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addRowData(2) ;
    dataset.addRowKey("H1") ;
    dataset.addRowKey("H2") ;
    dataset.addDatas(0, datas) ;
    dataset.addDatas(1, datas2) ;

    return dataset ;
  }

  private IJChart createChart5() {
    IJChart chart = ChartFactory.createHistogramChart("Histogram Demo 1", null, null,
                                                      createDataset5(), orientation, true, true) ;
    XYPlot plot = (XYPlot) chart.getPlot() ;
    plot.setForegroundAlpha(0.85F) ;
    IntervalXYValueAxis valueAxis = (IntervalXYValueAxis) plot.getValueAxis() ;
    valueAxis.setTickUnit(new LongTickUnit()) ;
    return chart ;
  }

  private static DefaultMatrixDataset createDataset6() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addRowKey("Classes") ;
    dataset.addColKey("JDK 1.0") ;
    dataset.addColKey("JDK 1.1") ;
    dataset.addColKey("SDK 1.2") ;
    dataset.addColKey("SDK 1.3") ;
    dataset.addColKey("SDK 1.4") ;
    dataset.addRowData(1) ;

    dataset.addData(0, new NumberChartData(212D)) ;
    dataset.addData(0, new NumberChartData(504D)) ;
    dataset.addData(0, new NumberChartData(1520D)) ;
    dataset.addData(0, new NumberChartData(1842D)) ;
    dataset.addData(0, new NumberChartData(2991D)) ;
    dataset.addData(0, new NumberChartData(3500D)) ;

    return dataset ;
  }

  private IJChart createChart6() {
    DefaultMatrixDataset dataset = createDataset6() ;
    IJChart chart = ChartFactory.createCategoryLineAndShapeChart("Java Standard Class Library",
                                                                 null, "Class Count", dataset,
                                                                 orientation, false, true) ;
    chart.addSubtitle(new TextTitle("Number of Classes By Release")) ;
    TextTitle texttitle = new TextTitle(
      "Source: Java In A Nutshell (5th Edition) by David Flanagan (O'Reilly)") ;
    texttitle.setTextFont(new Font("SansSerif", 0, 10)) ;
    texttitle.setPosition(RectangleEdge.BOTTOM) ;
    texttitle.setHorizontalAlignment(HorizontalAlignment.RIGHT) ;
    chart.addSubtitle(texttitle) ;

    CategoryPlot plot = (CategoryPlot) chart.getPlot() ;
    plot.setValueGridlineVisible(false) ;
    plot.setDomainGridlineVisible(false) ;

    NumberValueAxis numberaxis = (NumberValueAxis) plot.getValueAxis() ;
    numberaxis.setTickUnit(new LongTickUnit()) ;

    LineAndShapeRender render = (LineAndShapeRender) plot.getRender() ;
    render.setAutoSelectFillPaint(false) ;
    render.setBaseItemFillPaint(Color.white) ;
    render.setAutoSelectBorderStroke(false) ;
    render.setRowItemBorderStroke(0, new BasicStroke(3F)) ;

    plot.setDrawingSupplier(new DefaultDrawingSupplier() {
      public Shape getNextShape() {
        return new java.awt.geom.Ellipse2D.Double( -5D, -5D, 10D, 10D) ;
      }
    }) ;

    return chart ;
  }

}
