package demo.miscellaneous.annotations ;

import java.awt.Color ;
import java.awt.Font ;
import java.awt.GridLayout ;

import javax.swing.JPanel ;

import com.ijchart.xychart.annotation.CategoryTextAndPointerAnnotation ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.constant.HorizontalAlignment ;
import com.ijchart.xychart.data.NumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.plot.CategoryPlot ;
import com.ijchart.xychart.render.category.LineAndShapeRender ;
import com.ijchart.xychart.title.TextTitle ;
import com.ijchart.xychart.ui.RectangleEdge ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class CategoryPointerAnnotationDemo1 extends JPanel {

  public CategoryPointerAnnotationDemo1() {
    setLayout(new GridLayout(1, 1)) ;
    addPanel1() ;

  }

  private void addPanel1() {
    IMatrixDataset dataset = createDataset() ;
    IJChart chart = ChartFactory.createCategoryLineAndShapeChart(
      "Java Standard Class Library", "Release", "Class Count", dataset,
      ChartOrientation.VERTICAL, false, true) ;

    TextTitle title1 = new TextTitle("Number of Classes By Release", new Font("SansSerif", 0, 11)) ;
    chart.addSubtitle(title1) ;

    TextTitle texttitle = new TextTitle(
      "Source: Java In A Nutshell (4th Edition) by David Flanagan (O'Reilly)") ;
    texttitle.setTextFont(new Font("SansSerif", 1, 12)) ;
    texttitle.setPosition(RectangleEdge.BOTTOM) ;
    texttitle.setHorizontalAlignment(HorizontalAlignment.RIGHT) ;
    chart.addSubtitle(texttitle) ;

    CategoryPlot plot = (CategoryPlot) chart.getPlot() ;
    LineAndShapeRender render = (LineAndShapeRender) plot.getRender() ;
    render.setAutoSelectFillPaint(false) ;
    render.setBaseItemFillPaint(Color.white) ;
    plot.setValueGridlinePaint(Color.white) ;
    plot.getValueAxis().setUpperMargin(0.02D) ;
    plot.setDomainGridlineVisible(false) ;

    CategoryTextAndPointerAnnotation categorypointerannotation =
      new CategoryTextAndPointerAnnotation("Released 4-Dec-1998", "JDK 1.2", 1530D,
                                           -2.3561944901923448D) ;
    categorypointerannotation.setTextHorizontalAlign(HorizontalAlignment.RIGHT) ;
    render.addAnnotation(categorypointerannotation) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static IMatrixDataset createDataset() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addColKey("JDK 1.0") ;
    dataset.addColKey("JDK 1.1") ;
    dataset.addColKey("JDK 1.2") ;
    dataset.addColKey("JDK 1.3") ;
    dataset.addColKey("JDK 1.4") ;

    dataset.addRowKey("Classes") ;

    dataset.addRowData() ;
    dataset.addData(0, new NumberChartData(212D)) ;
    dataset.addData(0, new NumberChartData(504D)) ;
    dataset.addData(0, new NumberChartData(1520D)) ;
    dataset.addData(0, new NumberChartData(1842D)) ;
    dataset.addData(0, new NumberChartData(2991D)) ;

    return dataset ;
  }

}
