package demo.miscellaneous.itemlabel;

import java.awt.BorderLayout ;
import java.awt.Color ;
import java.awt.Font ;

import javax.swing.JPanel ;

import com.ijchart.xychart.axis.value.NumberValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.constant.TextPosition ;
import com.ijchart.xychart.data.NumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.label.LabelGeneratorAdaptor ;
import com.ijchart.xychart.plot.CategoryPlot ;
import com.ijchart.xychart.range.NumberRange ;
import com.ijchart.xychart.render.category.AbstractCategoryRender ;
import com.ijchart.xychart.ui.RectangleEdge ;
/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class ItemLabelDemo1 extends JPanel {
  private ChartOrientation orientation = ChartOrientation.VERTICAL ;

  public ItemLabelDemo1() {
    setLayout(new BorderLayout()) ;
    addPanel1() ;
  }

  private void addPanel1() {
    DefaultMatrixDataset dataset = createDataset() ;
    IJChart chart = ChartFactory.createCategoryBar2DChart("Item Label Demo 1", "Category",
                                                          "Value", dataset, orientation,
                                                          true, true) ;
    chart.getLegendTitle().setPosition(RectangleEdge.RIGHT) ;

    CategoryPlot plot = (CategoryPlot) chart.getPlot() ;
    AbstractCategoryRender render = plot.getRender() ;
    render.setBaseItemLabelVisible(true) ;
    render.setLabelGenerator(new LabelGenerator(50D)) ;
    render.setBaseItemLabelFont(new Font("Serif", 0, 20)) ;
    render.setBaseItemLabelPosition(TextPosition.OUTSIDE_TOP) ;
    ((NumberValueAxis) plot.getValueAxis()).setUserDefineDatasetRange(new NumberRange(0, 100)) ;

    plot.setValueGridlinePaint(Color.white) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel, BorderLayout.CENTER) ;
  }

  private static DefaultMatrixDataset createDataset() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addColKey("S1") ;
    for (int i = 1 ; i <= 5 ; i++) {
      dataset.addRowKey("C" + i) ;
    }
    dataset.addRowData(5) ;

    dataset.addData(0, new NumberChartData(11D)) ;
    dataset.addData(1, new NumberChartData(44.299999999999997D)) ;
    dataset.addData(2, new NumberChartData(93D)) ;
    dataset.addData(3, new NumberChartData(35.600000000000001D)) ;
    dataset.addData(4, new NumberChartData(75.099999999999994D)) ;

    return dataset ;
  }

  class LabelGenerator extends LabelGeneratorAdaptor {
    private double threshold ;

    public LabelGenerator(double d) {
      threshold = d ;
    }

    public String generateLabel(IMatrixDataset dataset, int row, int column) {
      String s = null ;
      NumberChartData number = (NumberChartData) dataset.getData(row, column) ;
      if (number != null) {
        double d = number.getValue() ;
        if (d > threshold) {
          s = String.valueOf(d) ;
        }
      }

      return s ;
    }

  }
}
