package demo.multipleaxischarts ;

import java.awt.Color ;
import java.awt.GridLayout ;

import javax.swing.JPanel ;

import com.ijchart.xychart.axis.value.NumberValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.AxisLocation ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.constant.IAngle ;
import com.ijchart.xychart.constant.LegendType ;
import com.ijchart.xychart.constant.RenderDrawOrder ;
import com.ijchart.xychart.data.NumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.plot.CategoryPlot ;
import com.ijchart.xychart.render.category.Line3DRender ;
import com.ijchart.xychart.ui.DefaultEffect3D ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class DualAxisDemo4 extends JPanel {

  public DualAxisDemo4() {
    setLayout(new GridLayout(1, 1)) ;
    createPanel1() ;
  }

  public void createPanel1() {
    IJChart chart = createChart() ;
    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static IJChart createChart() {
    IJChart chart = ChartFactory.createCategoryBar3DChart("Dual Axis Chart", "Category", "Value",
                                                          createDataset1(),
                                                          ChartOrientation.VERTICAL, true, true) ;
    CategoryPlot plot = (CategoryPlot) chart.getPlot() ;
    plot.setCategoryAxisLocation(AxisLocation.BOTTOM_OR_RIGHT) ;
    plot.setDomainGridlineVisible(false) ;

    IMatrixDataset dataset2 = createDataset2() ;
    Line3DRender shapeRender = new Line3DRender(new DefaultEffect3D(), dataset2) {
      public LegendType getLegendType() {
        return LegendType.ROW ;
      }
    } ;
    plot.setRender(1, shapeRender) ;
    shapeRender.setBaseItemFillPaint(Color.yellow) ;
    shapeRender.setAutoSelectFillPaint(false) ;

    NumberValueAxis numberaxis = new NumberValueAxis("Secondary", dataset2) ;
    numberaxis.setAxisLabelAngle(IAngle.ANGLE_DOWN_90) ;
    plot.setValueAxis(1, numberaxis) ;
    plot.setRenderDrawOrder(RenderDrawOrder.FORWARD) ;

    return chart ;
  }

  private static IMatrixDataset createDataset1() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    String s = "First" ;
    String s1 = "Second" ;
    String s2 = "Third" ;
    String s3 = "Category 1" ;
    String s4 = "Category 2" ;
    String s5 = "Category 3" ;
    String s6 = "Category 4" ;
    String s7 = "Category 5" ;

    dataset.addColKey(s) ;
    dataset.addColKey(s1) ;
    dataset.addColKey(s2) ;

    dataset.addRowKey(s3) ;
    dataset.addRowKey(s4) ;
    dataset.addRowKey(s5) ;
    dataset.addRowKey(s6) ;
    dataset.addRowKey(s7) ;

    dataset.addRowData(5) ;
    dataset.addData(0, new NumberChartData(1.0D)) ;
    dataset.addData(0, new NumberChartData(5D)) ;
    dataset.addData(0, new NumberChartData(4D)) ;

    dataset.addData(1, new NumberChartData(4D)) ;
    dataset.addData(1, new NumberChartData(7D)) ;
    dataset.addData(1, new NumberChartData(3D)) ;

    dataset.addData(2, new NumberChartData(3D)) ;
    dataset.addData(2, new NumberChartData(6D)) ;
    dataset.addData(2, new NumberChartData(2D)) ;

    dataset.addData(3, new NumberChartData(5D)) ;
    dataset.addData(3, new NumberChartData(8D)) ;
    dataset.addData(3, new NumberChartData(3D)) ;

    dataset.addData(4, new NumberChartData(5D)) ;
    dataset.addData(4, new NumberChartData(4D)) ;
    dataset.addData(4, new NumberChartData(6D)) ;

    return dataset ;
  }

  private static IMatrixDataset createDataset2() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    String s = "Fourth" ;
    String s1 = "Category 1" ;
    String s2 = "Category 2" ;
    String s3 = "Category 3" ;
    String s4 = "Category 4" ;
    String s5 = "Category 5" ;

    dataset.addRowKey(s) ;
    dataset.addColKey(s1) ;
    dataset.addColKey(s2) ;
    dataset.addColKey(s3) ;
    dataset.addColKey(s4) ;
    dataset.addColKey(s5) ;

    dataset.addRowData() ;
    dataset.addData(0, new NumberChartData(15D)) ;
    dataset.addData(0, new NumberChartData(20D)) ;
    dataset.addData(0, new NumberChartData(31D)) ;
    dataset.addData(0, new NumberChartData(25D)) ;
    dataset.addData(0, new NumberChartData(56D)) ;

    return dataset ;
  }

}
