package demo.others.categorycharts ;

import java.awt.GridLayout ;

import javax.swing.JPanel ;

import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.data.NumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class LevelChartPanel2 extends JPanel {

  private ChartOrientation vertical = ChartOrientation.VERTICAL ;

  private ChartOrientation horizontal = ChartOrientation.HORIZONTAL ;

  public LevelChartPanel2() {
    setLayout(new GridLayout(2, 2)) ;
    addPanel1() ;
    addPanel2() ;
    addPanel3() ;
    addPanel4() ;
  }

  private void addPanel1() {

    IMatrixDataset dataset = createDataset1() ;
    IJChart chart = ChartFactory.createCategoryLevelChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "y axis text", dataset, vertical, true, true) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private void addPanel2() {

    IJChart chart = ChartFactory.createCategoryLevelChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "y axis text", createDataset1(), horizontal, true, true) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private void addPanel3() {

    IJChart chart = ChartFactory.createCategoryLevelChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "y axis text", createDataset2(), vertical, true, true) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private void addPanel4() {

    IJChart chart = ChartFactory.createCategoryLevelChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "y axis text", createDataset2(), horizontal, true, true) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static IMatrixDataset createDataset1() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addRowKey("123456789011") ;
    dataset.addRowKey("ab\ncd\nef") ;
    dataset.addRowKey("abcde") ;
    dataset.addRowKey("12345678") ;
    dataset.addRowKey("") ;

    for (int i = 0 ; i < 5 ; i++) {
      dataset.addRowData() ;
      for (int j = 0 ; j <= 3 ; j++) {
        if (i == 0 && j % 5 != 0) {
          dataset.addColKey("col key " + j) ;
        } else {
          dataset.addColKey("long long long long col key " + j) ;
        }

        if (i % 2 == 0 && j == 3) {
          dataset.addData(i, null) ;
        } else {
          dataset.addData(i, new NumberChartData((i + 1) * j + 1 + Math.random())) ;
        }
      }
    }

    return dataset ;
  }

  private static IMatrixDataset createDataset2() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addRowKey("123456789011") ;
    dataset.addRowKey("ab\ncd\nef") ;
    dataset.addRowKey("abcde") ;
    dataset.addRowKey("12345678") ;
    dataset.addRowKey("") ;

    for (int i = 0 ; i < 5 ; i++) {
      dataset.addRowData() ;
      for (int j = 0 ; j <= 3 ; j++) {
        if (i == 0 && j % 5 != 0) {
          dataset.addColKey("col key " + j) ;
        } else {
          dataset.addColKey("long long long long col key " + j) ;
        }

        dataset.addData(i, new NumberChartData((i + 1) * j + 1 + Math.random())) ;

      }
    }

    return dataset ;
  }

}
