package demo.others.categorycharts ;

import java.awt.GridLayout ;

import javax.swing.JPanel ;

import com.ijchart.xychart.axis.value.AbstractValueAxis ;
import com.ijchart.xychart.axis.value.NumberValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.data.NumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.plot.CategoryPlot ;
import com.ijchart.xychart.render.category.AreaRender ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class OverlaidBarChartpPanel1 extends JPanel {

  private ChartOrientation vertical = ChartOrientation.VERTICAL ;

  private ChartOrientation horizontal = ChartOrientation.HORIZONTAL ;

  public OverlaidBarChartpPanel1() {
    setLayout(new GridLayout(1, 1)) ;
    addPanel1() ;
  }

  private void addPanel1() {

    IMatrixDataset dataset = createDataset1() ;
    IJChart chart = ChartFactory.createCategoryBar2DChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "y axis text", dataset, vertical, true, true) ;

    CategoryPlot plot = (CategoryPlot) chart.getPlot() ;
    AbstractValueAxis valueAxis = plot.getValueAxis() ;
    valueAxis.setLowerMargin(0.05) ;
    valueAxis.setUpperMargin(0.1) ;

    IMatrixDataset dataset2 = createDataset2() ;
    NumberValueAxis valueAxis2 = new NumberValueAxis("Value 2", dataset2) ;
    plot.setValueAxis(1, valueAxis2) ;
    AreaRender areaRender = new AreaRender(dataset2) ;
    areaRender.setDrawingSupplier(plot.getDrawingSupplier()) ;
    plot.setRender(1, areaRender) ;

    plot.setForegroundAlpha(0.8F) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static IMatrixDataset createDataset1() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addRowKey("123456789011") ;
    dataset.addRowKey("abncdnef") ;
    dataset.addRowKey("abcde") ;
    dataset.addRowKey("12345678") ;
    dataset.addRowKey("") ;

    for (int i = 0 ; i < 5 ; i++) {
      dataset.addRowData() ;
      for (int j = 0 ; j <= 4 ; j++) {
        if (i == 0 && j % 5 != 0) {
          dataset.addColKey("col key " + j) ;
        } else {
          dataset.addColKey("long long long long col key " + j) ;
        }

        if (i % 2 == 0 && j == 3) {
          dataset.addData(i, null) ;
        } else if (i % 2 == 0) {
          double value = -55 * ((i % 3) + 1) ;
          dataset.addData(i, new NumberChartData(value)) ;
        } else {
          double value = 55 * ((i % 3) + 1) ;
          dataset.addData(i, new NumberChartData(value)) ;
        }

      }
    }

    return dataset ;
  }

  private static IMatrixDataset createDataset2() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addRowKey("123456789011") ;
    dataset.addRowKey("abncdnef") ;
    dataset.addRowKey("abcde") ;

    double[][] values = { { -1.0D, 4D, 3D, 5D, 5D, 7D, 7D, 8D}
                        , {5D, 7D, -6D, 8D, 4D, -4D, 2D, 1.0D}, {4D, 3D, 2D, 3D, 6D, 3D, 4D, 3D}
    } ;

    for (int i = 0 ; i < values.length ; i++) {
      dataset.addRowData() ;
      for (int j = 0 ; j < values[i].length ; j++) {
        if (i == 0) {
          dataset.addColKey("Col key " + j) ;
        }

        dataset.addData(i, new NumberChartData(values[i][j])) ;
      }
    }

    return dataset ;
  }

}
