package demo.others.categorycharts;

import java.awt.GridLayout ;

import javax.swing.JPanel ;

import com.ijchart.xychart.axis.value.AbstractValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.data.NumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.plot.CategoryPlot ;
import com.ijchart.xychart.render.category.StackedBarRender ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class StackedBarChartPanel2 extends JPanel {

  private ChartOrientation vertical = ChartOrientation.VERTICAL ;

  private ChartOrientation horizontal = ChartOrientation.HORIZONTAL ;

  public StackedBarChartPanel2() {
    setLayout(new GridLayout(2, 2)) ;
    addPanel1() ;
    addPanel2() ;
    addPanel3() ;
    addPanel4() ;
  }

  private void addPanel1() {

    IMatrixDataset dataset = createDataset1() ;
    IJChart chart = ChartFactory.createStackedBarChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "y axis text", dataset, vertical, true, true) ;

    CategoryPlot plot = (CategoryPlot) chart.getPlot() ;
    StackedBarRender render = (StackedBarRender) plot.getRender() ;
    render.setRenderAsPercentages(true) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private void addPanel2() {

    IMatrixDataset dataset = createDataset1() ;
    IJChart chart = ChartFactory.createStackedBarChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "y axis text", dataset, vertical, true, true) ;
    CategoryPlot plot = (CategoryPlot) chart.getPlot() ;
    AbstractValueAxis valueAxis = plot.getValueAxis() ;
    valueAxis.setInverted(true) ;
    StackedBarRender render = (StackedBarRender) plot.getRender() ;
    render.setRenderAsPercentages(true) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private void addPanel3() {

    IJChart chart = ChartFactory.createStackedBarChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "%", createDataset2(), horizontal, true, true) ;
    CategoryPlot plot = (CategoryPlot) chart.getPlot() ;
    StackedBarRender render = (StackedBarRender) plot.getRender() ;
    render.setRenderAsPercentages(true) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private void addPanel4() {

    IJChart chart = ChartFactory.createStackedBarChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "%", createDataset2(), horizontal, true, true) ;
    CategoryPlot plot = (CategoryPlot) chart.getPlot() ;
    AbstractValueAxis valueAxis = plot.getValueAxis() ;
    valueAxis.setInverted(true) ;
    StackedBarRender render = (StackedBarRender) plot.getRender() ;
    render.setRenderAsPercentages(true) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static IMatrixDataset createDataset1() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addRowKey("123456789011") ;
    dataset.addRowKey("ab\ncd\nef") ;
    dataset.addRowKey("abcde") ;
    dataset.addRowKey("12345678") ;
    dataset.addRowKey("") ;

    dataset.addColKey("col key 1") ;
    dataset.addColKey("col key 2") ;
    dataset.addColKey("col key 3") ;

    int m = 0 ;
    dataset.addRowData() ;
    dataset.addData(m, new NumberChartData(330)) ;
    dataset.addData(m, new NumberChartData(330)) ;
    dataset.addData(m++, new NumberChartData(340)) ;

    dataset.addRowData() ;
    dataset.addData(m, new NumberChartData(30)) ;
    dataset.addData(m, new NumberChartData(530)) ;
    dataset.addData(m++, new NumberChartData(440)) ;

    dataset.addRowData() ;
    dataset.addData(m, new NumberChartData(330)) ;
    dataset.addData(m, new NumberChartData(330)) ;
    dataset.addData(m++, new NumberChartData(340)) ;

    dataset.addRowData() ;
    dataset.addData(m, new NumberChartData(330)) ;
    dataset.addData(m, new NumberChartData(430)) ;
    dataset.addData(m++, new NumberChartData(240)) ;

    dataset.addRowData() ;
    dataset.addData(m, new NumberChartData(40)) ;
    dataset.addData(m, new NumberChartData(430)) ;
    dataset.addData(m++, new NumberChartData(440)) ;

    dataset.addRowData() ;
    dataset.addData(m, new NumberChartData(360)) ;
    dataset.addData(m, new NumberChartData(300)) ;
    dataset.addData(m++, new NumberChartData(340)) ;

    return dataset ;
  }

  private static IMatrixDataset createDataset2() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addRowKey("123456789011") ;
    dataset.addRowKey("ab\ncd\nef") ;
    dataset.addRowKey("abcde") ;
    dataset.addRowKey("12345678") ;
    dataset.addRowKey("") ;

    int m = 0 ;
    dataset.addRowData() ;
    dataset.addData(m, new NumberChartData(330)) ;
    dataset.addData(m, new NumberChartData( -330)) ;
    dataset.addData(m++, new NumberChartData(340)) ;

    dataset.addRowData() ;
    dataset.addData(m, new NumberChartData(30)) ;
    dataset.addData(m, new NumberChartData( -53)) ;
    dataset.addData(m++, new NumberChartData(440)) ;

    dataset.addRowData() ;
    dataset.addData(m, new NumberChartData(3300)) ;
    dataset.addData(m, null) ;
    dataset.addData(m++, new NumberChartData( -340)) ;

    return dataset ;
  }

}
