package demo.others.metercharts ;

import java.awt.BorderLayout ;
import java.awt.Color ;
import java.awt.GridLayout ;
import java.awt.event.ActionEvent ;
import java.awt.event.ActionListener ;

import javax.swing.JButton ;
import javax.swing.JPanel ;
import javax.swing.JSlider ;
import javax.swing.event.ChangeEvent ;
import javax.swing.event.ChangeListener ;

import com.ijchart.xychart.chartinfo.RenderShapeCollection ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.MeterShapeType ;
import com.ijchart.xychart.data.StartEndNumberChartData ;
import com.ijchart.xychart.dataset.SingleRowDataset ;
import com.ijchart.xychart.plot.NoAxisPlot ;
import com.ijchart.xychart.render.noaxis.MeterRender ;
import com.ijchart.xychart.shape.IChartShape ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class MeterChartPanel4 extends JPanel {

  private IJChart chart = null ;

  public MeterChartPanel4() {
    setLayout(new GridLayout(1, 1)) ;
    addPanel1() ;
  }

  private void addPanel1() {
    createChart() ;
    final ChartPanel chartPanel = new ChartPanel(chart) ;
    JPanel jpanel = new JPanel(new BorderLayout()) ;

    JSlider jslider = new JSlider( -10, 70, 50) ;
    jslider.setMajorTickSpacing(10) ;
    jslider.setMinorTickSpacing(5) ;
    jslider.setPaintLabels(true) ;
    jslider.setPaintTicks(true) ;

    JPanel sliderPanel = new JPanel() ;
    sliderPanel.add(jslider) ;
    JButton button = new JButton("change shape") ;
    button.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        RenderShapeCollection renderShapes = (RenderShapeCollection) chart.getChartShapes().
                                             getPlotShapes().getAllRenderShapes().get(0) ;
        IChartShape shape = (IChartShape) renderShapes.getDataItemShapes().get(0) ;
        shape.translate(10, 10) ;
//        chart.getChartShapes().forceChartChanged() ;
        chartPanel.repaint() ;
      }
    }) ;
    sliderPanel.add(button) ;

    jpanel.add(BorderLayout.SOUTH, sliderPanel) ;
    add(jpanel) ;

    jslider.addChangeListener(new ChangeListener() {
      public void stateChanged(ChangeEvent changeevent) {
        JSlider jslider1 = (JSlider) changeevent.getSource() ;
        if (chart != null) {
          NoAxisPlot noAxisPlot = (NoAxisPlot) chart.getPlot() ;
          MeterRender render = (MeterRender) noAxisPlot.getRender(0) ;
          render.setValue(jslider1.getValue()) ;
        }
      }
    }) ;

    jpanel.add(chartPanel) ;
  }

  private void createChart() {
    SingleRowDataset dataset = createDataset() ;
    chart = ChartFactory.createMeterChart(
      "This is a very long title,it has many words and wrap automatically.", dataset, true, true) ;
    NoAxisPlot plot = (NoAxisPlot) chart.getPlot() ;
    MeterRender render = (MeterRender) plot.getRender() ;
    render.setValue(10.0) ;
    render.setBackgroundPaint(Color.YELLOW) ;
    render.setMeterAngle(190) ;
    render.setMeterShapeType(MeterShapeType.PIE) ;

    render.setBaseItemDrawBorder(true) ;
    render.setBaseItemFill(true) ;

  }

  private void addPanel2() {
    JPanel jpanel = new JPanel() ;
    add(jpanel) ;

    SingleRowDataset dataset = createDataset() ;
    chart = ChartFactory.createMeterChart(
      "This is a very long title,it has many words and wrap automatically.", dataset, true, true) ;
    NoAxisPlot plot = (NoAxisPlot) chart.getPlot() ;
    MeterRender render = (MeterRender) plot.getRender() ;
    render.setValue(10.0) ;
    render.setBackgroundPaint(Color.YELLOW) ;
    render.setMeterAngle(60) ;
    render.setMeterShapeType(MeterShapeType.PIE) ;

    ChartPanel chartPanel = new ChartPanel(chart) ;
    jpanel.add(BorderLayout.NORTH, chartPanel) ;
  }

  private static SingleRowDataset createDataset() {
    SingleRowDataset volumeDataset = new SingleRowDataset() ;
    volumeDataset.addRowKey("Volume") ;
    volumeDataset.addRowData() ;

    volumeDataset.addColKey("Normal") ;
    volumeDataset.addColKey("Warning") ;
    volumeDataset.addColKey("Critical") ;

    volumeDataset.addData(0, new StartEndNumberChartData(0.0D, 35D)) ;
    volumeDataset.addData(0, new StartEndNumberChartData(35D, 50D)) ;
    volumeDataset.addData(0, new StartEndNumberChartData(50D, 60D)) ;

    return volumeDataset ;
  }

}
