package demo.others.shapes;

import java.awt.Color ;
import java.awt.Dimension ;
import java.awt.Graphics ;
import java.awt.Graphics2D ;
import java.awt.GridLayout ;
import java.awt.event.MouseEvent ;
import java.awt.event.MouseMotionAdapter ;
import java.awt.geom.GeneralPath ;

import javax.swing.JLabel ;
import javax.swing.JPanel ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class PathAppendPanel extends JPanel {
  private JLabel label ;

  public PathAppendPanel() {
    setLayout(new GridLayout(1, 2)) ;
    label = new JLabel("begin") ;
    add(label) ;

    addPanel1() ;
  }

  private void addPanel1() {
    final GeneralPath path = new GeneralPath() ;

    JPanel panel = new JPanel() {
      public void paint(Graphics g) {
        super.paintComponent(g) ;
        Graphics2D g2 = (Graphics2D) g ;
        setBackground(Color.white) ;
        g2.setPaint(Color.red) ;

        path.moveTo(3, 3) ;
        path.lineTo(50, 3) ;
        path.lineTo(50, 50) ;
        path.lineTo(3, 50) ;
        path.closePath() ;

        GeneralPath path2 = new GeneralPath() ;
        path2.moveTo(100, 3) ;
        path2.lineTo(150, 3) ;
        path2.lineTo(150, 53) ;
        path2.lineTo(100, 53) ;
        path2.closePath() ;

        path.append(path2, false) ;

        g2.draw(path) ;
      }
    } ;

    panel.addMouseMotionListener(new MouseMotionAdapter() {
      public void mouseMoved(MouseEvent e) {
        label.setText("(" + e.getX() + "," + e.getY() + ")" + path.contains(e.getX(), e.getY())) ;
      }
    }) ;

    panel.setPreferredSize(new Dimension(300, 300)) ;
    add(panel) ;
  }

}
