package demo.others.shapes ;

import java.awt.BasicStroke ;
import java.awt.Color ;
import java.awt.Dimension ;
import java.awt.Graphics ;
import java.awt.Graphics2D ;
import java.awt.GridLayout ;
import java.awt.event.MouseEvent ;
import java.awt.event.MouseMotionAdapter ;
import java.awt.geom.Point2D ;
import java.awt.geom.Rectangle2D ;
import java.awt.image.BufferedImage ;
import java.io.File ;
import java.io.IOException ;

import javax.imageio.ImageIO ;
import javax.swing.BorderFactory ;
import javax.swing.JLabel ;
import javax.swing.JPanel ;

import com.ijchart.xychart.constant.HorizontalAlignment ;
import com.ijchart.xychart.constant.VerticalAlignment ;
import com.ijchart.xychart.shape.RectangleImageChartShape ;
import com.ijchart.xychart.test.SerialTestUtil ;
import com.ijchart.xychart.ui.RectangleInsets ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class RectangleImageChartShapePanel extends JPanel {
  private JLabel label ;

  private BufferedImage image = null ;

  private BufferedImage image2 = null ;

  public RectangleImageChartShapePanel() {
    try {
      image = ImageIO.read(new File("E:\\IJChart\\images\\add.gif")) ;
    } catch (IOException ex) {
      ex.printStackTrace() ;
    }

    try {
      image2 = ImageIO.read(new File("E:\\IJChart\\images\\2002.jpg")) ;
    } catch (IOException ex) {
      ex.printStackTrace() ;
    }

    init() ;
  }

  private void init() {
    setLayout(new GridLayout(5, 3)) ;
    addPanel1() ;
    addPanel2() ;
    addPanel3() ;
    addPanel4() ;
    addPanel5() ;
    addPanel6() ;
    addPanel7() ;
    addPanel8() ;
    addPanel9() ;
    addPanel10() ;
    addPanel11() ;
    addPanel12() ;
    addPanel13() ;
    addPanel14() ;
    label = new JLabel("begin") ;
    add(label) ;
  }

  private void addPanel1() {
    final RectangleImageChartShape shape = new RectangleImageChartShape(
      new Rectangle2D.Double(10, 10, 100, 100), image2) ;
    shape.setMargin(new RectangleInsets(2, 2, 2, 2)) ;
    shape.setRotate(Math.PI / 10) ;
    shape.setDrawBorder(true) ;
    shape.setBorderStroke(new BasicStroke(10)) ;
    shape.setBorderPaint(Color.RED) ;
    shape.setSelectAnchorPaint(Color.BLUE) ;

    JPanel panel = new JPanel() {

      public void paint(Graphics g) {
        setBackground(Color.white) ;
        super.paintComponent(g) ;
        Graphics2D g2 = (Graphics2D) g ;

        shape.setSelected(true) ;
        shape.draw((Graphics2D) g) ;

        Point2D p = shape.getLockPoint() ;
        g.setColor(Color.red) ;
        g.fillRect((int) p.getX(), (int) p.getY(), 2, 2) ;
      }

    } ;

    panel.addMouseMotionListener(new MouseMotionAdapter() {
      public void mouseMoved(MouseEvent e) {
        label.setText("(" + e.getX() + "," + e.getY() + ")" + shape.contains(e.getX(), e.getY())) ;
      }
    }) ;
    panel.setPreferredSize(new Dimension(150, 150)) ;
    panel.setBorder(BorderFactory.createLineBorder(Color.red)) ;
    add(panel) ;
  }

  private void addPanel2() {
    final RectangleImageChartShape shape = new RectangleImageChartShape(
      new Rectangle2D.Double(10, 10, 100, 100), image) ;
    shape.setMargin(new RectangleInsets(2, 2, 2, 2)) ;
    //shape.setRotate(Math.PI / 10) ;
    shape.setDrawBorder(true) ;
    shape.setBorderPaint(Color.RED) ;
    shape.setSelectAnchorPaint(Color.BLUE) ;

    JPanel panel = new JPanel() {

      public void paint(Graphics g) {
        setBackground(Color.white) ;
        super.paintComponent(g) ;

        shape.setSelected(true) ;
        shape.draw((Graphics2D) g) ;
      }

    } ;

    panel.addMouseMotionListener(new MouseMotionAdapter() {
      public void mouseMoved(MouseEvent e) {
        label.setText("(" + e.getX() + "," + e.getY() + ")" + shape.contains(e.getX(), e.getY())) ;
      }
    }) ;
    panel.setPreferredSize(new Dimension(150, 150)) ;
    panel.setBorder(BorderFactory.createLineBorder(Color.red)) ;
    add(panel) ;
  }

  private void addPanel3() {
    final RectangleImageChartShape shape = new RectangleImageChartShape(
      new Rectangle2D.Double(10, 10, 100, 100), image) ;
    shape.setMargin(new RectangleInsets(2, 2, 2, 2)) ;
    //shape.setRotate(Math.PI / 10) ;
    shape.setDrawBorder(true) ;
    shape.setBorderStroke(new BasicStroke(10)) ;
    shape.setMargin(RectangleInsets.INSETS_ZERO) ;
    shape.setBorderPaint(Color.RED) ;
    shape.setSelectAnchorPaint(Color.BLUE) ;
    shape.setImageHorizontalAlign(HorizontalAlignment.LEFT) ;
    shape.setImageVerticalAlign(VerticalAlignment.TOP) ;

    JPanel panel = new JPanel() {

      public void paint(Graphics g) {
        setBackground(Color.white) ;
        super.paintComponent(g) ;

        Graphics2D g2 = (Graphics2D) g ;
        shape.setSelected(true) ;
        shape.draw((Graphics2D) g) ;

        Point2D p = shape.getLockPoint() ;
        g.setColor(Color.red) ;
        g.fillRect((int) p.getX(), (int) p.getY(), 2, 2) ;
      }

    } ;

    panel.addMouseMotionListener(new MouseMotionAdapter() {
      public void mouseMoved(MouseEvent e) {
        label.setText("(" + e.getX() + "," + e.getY() + ")" + shape.contains(e.getX(), e.getY())) ;
      }
    }) ;
    panel.setPreferredSize(new Dimension(150, 150)) ;
    panel.setBorder(BorderFactory.createLineBorder(Color.red)) ;
    add(panel) ;
  }

  private void addPanel4() {
    final RectangleImageChartShape shape = new RectangleImageChartShape(
      new Rectangle2D.Double(10, 10, 100, 100), image) ;
    shape.setMargin(new RectangleInsets(2, 2, 2, 2)) ;
    //shape.setRotate(Math.PI / 10) ;
    shape.setDrawBorder(true) ;
    shape.setBorderPaint(Color.RED) ;
    shape.setSelectAnchorPaint(Color.BLUE) ;
    shape.setImageHorizontalAlign(HorizontalAlignment.CENTER) ;
    shape.setImageVerticalAlign(VerticalAlignment.TOP) ;

    JPanel panel = new JPanel() {

      public void paint(Graphics g) {
        setBackground(Color.white) ;
        super.paintComponent(g) ;

        shape.draw((Graphics2D) g) ;
      }

    } ;

    panel.addMouseMotionListener(new MouseMotionAdapter() {
      public void mouseMoved(MouseEvent e) {
        label.setText("(" + e.getX() + "," + e.getY() + ")" + shape.contains(e.getX(), e.getY())) ;
      }
    }) ;
    panel.setPreferredSize(new Dimension(150, 150)) ;
    panel.setBorder(BorderFactory.createLineBorder(Color.red)) ;
    add(panel) ;
  }

  private void addPanel5() {
    final RectangleImageChartShape shape = new RectangleImageChartShape(
      new Rectangle2D.Double(10, 10, 100, 100), image) ;
    shape.setMargin(new RectangleInsets(2, 2, 2, 2)) ;
    //shape.setRotate(Math.PI / 10) ;
    shape.setDrawBorder(true) ;
    shape.setBorderPaint(Color.RED) ;
    shape.setSelectAnchorPaint(Color.BLUE) ;
    shape.setImageHorizontalAlign(HorizontalAlignment.RIGHT) ;
    shape.setImageVerticalAlign(VerticalAlignment.TOP) ;

    JPanel panel = new JPanel() {

      public void paint(Graphics g) {
        setBackground(Color.white) ;
        super.paintComponent(g) ;

        shape.setSelected(true);
        shape.draw((Graphics2D) g) ;
      }

    } ;

    panel.addMouseMotionListener(new MouseMotionAdapter() {
      public void mouseMoved(MouseEvent e) {
        label.setText("(" + e.getX() + "," + e.getY() + ")" + shape.contains(e.getX(), e.getY())) ;
      }
    }) ;
    panel.setPreferredSize(new Dimension(150, 150)) ;
    panel.setBorder(BorderFactory.createLineBorder(Color.red)) ;
    add(panel) ;
  }

  private void addPanel6() {
    final RectangleImageChartShape shape = new RectangleImageChartShape(
      new Rectangle2D.Double(10, 10, 100, 100), image) ;
    shape.setMargin(new RectangleInsets(2, 2, 2, 2)) ;
    //shape.setRotate(Math.PI / 10) ;
    shape.setDrawBorder(true) ;
    shape.setBorderPaint(Color.RED) ;
    shape.setSelectAnchorPaint(Color.BLUE) ;
    shape.setImageHorizontalAlign(HorizontalAlignment.LEFT) ;
    shape.setImageVerticalAlign(VerticalAlignment.CENTER) ;

    JPanel panel = new JPanel() {

      public void paint(Graphics g) {
        setBackground(Color.white) ;
        super.paintComponent(g) ;

        shape.setSelected(true);
        shape.draw((Graphics2D) g) ;
      }

    } ;

    panel.addMouseMotionListener(new MouseMotionAdapter() {
      public void mouseMoved(MouseEvent e) {
        label.setText("(" + e.getX() + "," + e.getY() + ")" + shape.contains(e.getX(), e.getY())) ;
      }
    }) ;
    panel.setPreferredSize(new Dimension(150, 150)) ;
    panel.setBorder(BorderFactory.createLineBorder(Color.red)) ;
    add(panel) ;
  }

  private void addPanel7() {
    final RectangleImageChartShape shape = new RectangleImageChartShape(
      new Rectangle2D.Double(10, 10, 100, 100), image) ;
    shape.setMargin(new RectangleInsets(2, 2, 2, 2)) ;
    //shape.setRotate(Math.PI / 10) ;
    shape.setDrawBorder(true) ;
    shape.setBorderPaint(Color.RED) ;
    shape.setSelectAnchorPaint(Color.BLUE) ;
    shape.setImageHorizontalAlign(HorizontalAlignment.CENTER) ;
    shape.setImageVerticalAlign(VerticalAlignment.CENTER) ;

    JPanel panel = new JPanel() {

      public void paint(Graphics g) {
        setBackground(Color.white) ;
        super.paintComponent(g) ;

        shape.setSelected(true);
        shape.draw((Graphics2D) g) ;
      }

    } ;

    panel.addMouseMotionListener(new MouseMotionAdapter() {
      public void mouseMoved(MouseEvent e) {
        label.setText("(" + e.getX() + "," + e.getY() + ")" + shape.contains(e.getX(), e.getY())) ;
      }
    }) ;
    panel.setPreferredSize(new Dimension(150, 150)) ;
    panel.setBorder(BorderFactory.createLineBorder(Color.red)) ;
    add(panel) ;
  }

  private void addPanel8() {
    final RectangleImageChartShape shape = new RectangleImageChartShape(
      new Rectangle2D.Double(10, 10, 100, 100), image) ;
    shape.setMargin(new RectangleInsets(2, 2, 2, 2)) ;
    //shape.setRotate(Math.PI / 10) ;
    shape.setDrawBorder(true) ;
    shape.setBorderPaint(Color.RED) ;
    shape.setSelectAnchorPaint(Color.BLUE) ;
    shape.setImageHorizontalAlign(HorizontalAlignment.RIGHT) ;
    shape.setImageVerticalAlign(VerticalAlignment.CENTER) ;

    JPanel panel = new JPanel() {

      public void paint(Graphics g) {
        setBackground(Color.white) ;
        super.paintComponent(g) ;

        shape.setSelected(true);
        shape.draw((Graphics2D) g) ;
      }

    } ;

    panel.addMouseMotionListener(new MouseMotionAdapter() {
      public void mouseMoved(MouseEvent e) {
        label.setText("(" + e.getX() + "," + e.getY() + ")" + shape.contains(e.getX(), e.getY())) ;
      }
    }) ;
    panel.setPreferredSize(new Dimension(150, 150)) ;
    panel.setBorder(BorderFactory.createLineBorder(Color.red)) ;
    add(panel) ;
  }

  private void addPanel9() {
    final RectangleImageChartShape shape = new RectangleImageChartShape(
      new Rectangle2D.Double(10, 10, 100, 100), image) ;
    shape.setMargin(new RectangleInsets(2, 2, 2, 2)) ;
    //shape.setRotate(Math.PI / 10) ;
    shape.setDrawBorder(true) ;
    shape.setBorderPaint(Color.RED) ;
    shape.setSelectAnchorPaint(Color.BLUE) ;
    shape.setImageHorizontalAlign(HorizontalAlignment.LEFT) ;
    shape.setImageVerticalAlign(VerticalAlignment.BOTTOM) ;

    JPanel panel = new JPanel() {

      public void paint(Graphics g) {
        setBackground(Color.white) ;
        super.paintComponent(g) ;

        shape.setSelected(true);
        shape.draw((Graphics2D) g) ;
      }

    } ;

    panel.addMouseMotionListener(new MouseMotionAdapter() {
      public void mouseMoved(MouseEvent e) {
        label.setText("(" + e.getX() + "," + e.getY() + ")" + shape.contains(e.getX(), e.getY())) ;
      }
    }) ;
    panel.setPreferredSize(new Dimension(150, 150)) ;
    panel.setBorder(BorderFactory.createLineBorder(Color.red)) ;
    add(panel) ;
  }

  private void addPanel10() {
    final RectangleImageChartShape shape = new RectangleImageChartShape(
      new Rectangle2D.Double(10, 10, 100, 100), image) ;
    shape.setMargin(new RectangleInsets(2, 2, 2, 2)) ;
    //shape.setRotate(Math.PI / 10) ;
    shape.setDrawBorder(true) ;
    shape.setBorderPaint(Color.RED) ;
    shape.setSelectAnchorPaint(Color.BLUE) ;
    shape.setImageHorizontalAlign(HorizontalAlignment.CENTER) ;
    shape.setImageVerticalAlign(VerticalAlignment.BOTTOM) ;

    JPanel panel = new JPanel() {

      public void paint(Graphics g) {
        setBackground(Color.white) ;
        super.paintComponent(g) ;

        shape.setSelected(true);
        shape.draw((Graphics2D) g) ;
      }

    } ;

    panel.addMouseMotionListener(new MouseMotionAdapter() {
      public void mouseMoved(MouseEvent e) {
        label.setText("(" + e.getX() + "," + e.getY() + ")" + shape.contains(e.getX(), e.getY())) ;
      }
    }) ;
    panel.setPreferredSize(new Dimension(150, 150)) ;
    panel.setBorder(BorderFactory.createLineBorder(Color.red)) ;
    add(panel) ;
  }

  private void addPanel11() {
    final RectangleImageChartShape shape = new RectangleImageChartShape(
      new Rectangle2D.Double(10, 10, 100, 100), image) ;
    shape.setMargin(new RectangleInsets(2, 2, 2, 2)) ;
    //shape.setRotate(Math.PI / 10) ;
    shape.setDrawBorder(true) ;
    shape.setBorderPaint(Color.RED) ;
    shape.setSelectAnchorPaint(Color.BLUE) ;
    shape.setImageHorizontalAlign(HorizontalAlignment.RIGHT) ;
    shape.setImageVerticalAlign(VerticalAlignment.BOTTOM) ;

    JPanel panel = new JPanel() {

      public void paint(Graphics g) {
        setBackground(Color.white) ;
        super.paintComponent(g) ;

        shape.setSelected(true);
        shape.draw((Graphics2D) g) ;
      }

    } ;

    panel.addMouseMotionListener(new MouseMotionAdapter() {
      public void mouseMoved(MouseEvent e) {
        label.setText("(" + e.getX() + "," + e.getY() + ")" + shape.contains(e.getX(), e.getY())) ;
      }
    }) ;
    panel.setPreferredSize(new Dimension(150, 150)) ;
    panel.setBorder(BorderFactory.createLineBorder(Color.red)) ;
    add(panel) ;
  }

  private void addPanel12() {
    final RectangleImageChartShape shape = new RectangleImageChartShape(
      new Rectangle2D.Double(10, 10, 20, 16), image) ;
    shape.setMargin(RectangleInsets.INSETS_ONE) ;
    //shape.setRotate(Math.PI / 10) ;
    shape.setDrawBorder(true) ;
    shape.setBorderPaint(Color.RED) ;
    shape.setSelectAnchorPaint(Color.BLUE) ;
    shape.setImageHorizontalAlign(HorizontalAlignment.RIGHT) ;
    shape.setImageVerticalAlign(VerticalAlignment.BOTTOM) ;

    JPanel panel = new JPanel() {

      public void paint(Graphics g) {
        setBackground(Color.white) ;
        super.paintComponent(g) ;

        shape.draw((Graphics2D) g) ;
//          shape.drawSelect((Graphics2D) g) ;
      }

    } ;

    panel.addMouseMotionListener(new MouseMotionAdapter() {
      public void mouseMoved(MouseEvent e) {
        label.setText("(" + e.getX() + "," + e.getY() + ")" + shape.contains(e.getX(), e.getY())) ;
      }
    }) ;
    panel.setPreferredSize(new Dimension(150, 150)) ;
    panel.setBorder(BorderFactory.createLineBorder(Color.red)) ;
    add(panel) ;
  }

  private void addPanel13() {
    final RectangleImageChartShape shape = new RectangleImageChartShape(
      new Rectangle2D.Double(10, 10, 100, 100), image) ;
    shape.setMargin(RectangleInsets.INSETS_ONE) ;
    //shape.setRotate(Math.PI / 10) ;
    shape.setDrawBorder(true) ;
    shape.setBorderPaint(Color.RED) ;
    shape.setSelectAnchorPaint(Color.BLUE) ;
    shape.setImageHorizontalAlign(HorizontalAlignment.RIGHT) ;
    shape.setImageVerticalAlign(VerticalAlignment.BOTTOM) ;
    shape.setFillShape(true) ;

    JPanel panel = new JPanel() {

      public void paint(Graphics g) {
        setBackground(Color.white) ;
        super.paintComponent(g) ;

        shape.draw((Graphics2D) g) ;
//          shape.drawSelect((Graphics2D) g) ;
      }

    } ;

    panel.addMouseMotionListener(new MouseMotionAdapter() {
      public void mouseMoved(MouseEvent e) {
        label.setText("(" + e.getX() + "," + e.getY() + ")" + shape.contains(e.getX(), e.getY())) ;
      }
    }) ;
    panel.setPreferredSize(new Dimension(150, 150)) ;
    panel.setBorder(BorderFactory.createLineBorder(Color.red)) ;
    add(panel) ;
  }

  private void addPanel14() {
    RectangleImageChartShape shape = new RectangleImageChartShape(
      new Rectangle2D.Double(10, 10, 100, 100), image) ;
    shape.setMargin(RectangleInsets.INSETS_ONE) ;
    //shape.setRotate(Math.PI / 10) ;
    shape.setDrawBorder(true) ;
    shape.setBorderPaint(Color.RED) ;
    shape.setSelectAnchorPaint(Color.BLUE) ;
    shape.setImageHorizontalAlign(HorizontalAlignment.RIGHT) ;
    shape.setImageVerticalAlign(VerticalAlignment.BOTTOM) ;
    shape.setFillShape(true) ;

    try {
      RectangleImageChartShape cloneShape = (RectangleImageChartShape) shape.clone() ;
      SerialTestUtil.serialObject(cloneShape) ;
    } catch (CloneNotSupportedException ex1) {
      ex1.printStackTrace() ;
    }
    final RectangleImageChartShape serialShape = (RectangleImageChartShape) SerialTestUtil.
                                                 unserialObject() ;
    serialShape.setImage(image) ;

    JPanel panel = new JPanel() {

      public void paint(Graphics g) {
        setBackground(Color.white) ;
        super.paintComponent(g) ;

        serialShape.draw((Graphics2D) g) ;
//          shape.drawSelect((Graphics2D) g) ;
      }

    } ;

    panel.addMouseMotionListener(new MouseMotionAdapter() {
      public void mouseMoved(MouseEvent e) {
        label.setText("(" + e.getX() + "," + e.getY() + ")" + serialShape.contains(e.getX(), e.getY())) ;
      }
    }) ;
    panel.setPreferredSize(new Dimension(150, 150)) ;
    panel.setBorder(BorderFactory.createLineBorder(Color.red)) ;
    add(panel) ;
  }

}
