package demo.others.shapes ;

import java.awt.Color ;
import java.awt.Dimension ;
import java.awt.Graphics ;
import java.awt.Graphics2D ;
import java.awt.GridLayout ;
import java.awt.RenderingHints ;
import java.awt.event.MouseEvent ;
import java.awt.event.MouseMotionAdapter ;
import java.awt.geom.Arc2D ;
import java.awt.geom.Point2D ;
import java.awt.geom.Rectangle2D ;
import java.util.HashMap ;
import java.util.Map ;

import javax.swing.BorderFactory ;
import javax.swing.JLabel ;
import javax.swing.JPanel ;

import com.ijchart.xychart.shape.RingChartShape ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class RingChartShapePanel extends JPanel {
  private Map hashMap = new HashMap() ;

  private JLabel label ;

  private final double arcWidth = 150 ;

  private final double arcHeight = 120 ;

  public RingChartShapePanel() {
    init() ;
  }

  private void init() {
    hashMap.put(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON) ;

    setLayout(new GridLayout(4, 3)) ;
    addPanel1() ;
    addPanel2() ;
    addPanel3() ;
    addPanel4() ;
    addPanel5() ;
    addPanel6() ;
    addPanel7() ;
    addPanel8() ;
    addPanel9() ;

    label = new JLabel("begin") ;
    add(label) ;
  }

  private void addPanel1() {
    final double angleSize = 60 ;

    addRingShape(arcWidth, arcHeight, 30, angleSize) ;
  }

  private void addPanel2() {
    final double angleSize = 90 ;

    addRingShape(arcWidth, arcHeight, 30, angleSize) ;
  }

  private void addPanel3() {
    final double angleSize = 135 ;

    addRingShape(arcWidth, arcHeight, 30, angleSize) ;
  }

  private void addPanel4() {
    final double angleSize = 180 ;

    addRingShape(arcWidth, arcHeight, 30, angleSize) ;
  }

  private void addPanel5() {
    final double angleSize = 225 ;

    addRingShape(arcWidth, arcHeight, 30, angleSize) ;
  }

  private void addPanel6() {
    final double angleSize = 270 ;

    addRingShape(arcWidth, arcHeight, 30, angleSize) ;
  }

  private void addPanel7() {
    final double angleSize = 315 ;

    addRingShape(arcWidth, arcHeight, 30, angleSize) ;
  }

  private void addPanel8() {
    final double angleSize = 360 ;

    addRingShape(arcWidth, arcHeight, 30, angleSize) ;
  }

  private void addPanel9() {
    final double angleSize = 355 ;

    addRingShape(arcWidth, arcHeight, 30, angleSize) ;
  }

  private void addRingShape(final double width, final double height, double startAngle,
                            double angleExtent) {
    final Arc2D arc = new Arc2D.Double(20, 20, width, height, startAngle, angleExtent, Arc2D.PIE) ;

    Rectangle2D rect = new Rectangle2D.Double(0, 0, 1, 1) ;
    final RingChartShape shape = new RingChartShape(arc, rect, "Label") ;
    shape.setFillShape(true) ;
    shape.setFillPaint(Color.blue) ;
    shape.setDrawBorder(true) ;
    shape.setBorderPaint(Color.red) ;

    JPanel panel = new JPanel() {
      public void paint(Graphics g) {
        Graphics2D g2 = (Graphics2D) g ;
        g2.addRenderingHints(hashMap) ;

        super.paintComponent(g) ;
        setBackground(Color.lightGray) ;

        g2.setPaint(Color.red) ;
        g2.draw(new Rectangle2D.Double(20, 20, width, height)) ;

        shape.setSelected(true) ;
        shape.draw(g2) ;

        Point2D p = shape.getLockPoint() ;
        g.setColor(Color.red) ;
        g.fillRect((int) p.getX(), (int) p.getY(), 2, 2) ;
      }
    } ;

    panel.addMouseMotionListener(new MouseMotionAdapter() {
      public void mouseMoved(MouseEvent e) {
        label.setText("(" + e.getX() + "," + e.getY() + ")" + shape.contains(e.getX(), e.getY())) ;
      }
    }) ;

    panel.setPreferredSize(new Dimension(160, 160)) ;
    panel.setBorder(BorderFactory.createLineBorder(Color.red)) ;
    add(panel) ;
  }

}
