package demo.others.xy ;

import java.awt.GridLayout ;
import java.util.Date ;

import javax.swing.JPanel ;

import com.ijchart.xychart.axis.value.AbstractValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.data.XYNumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.plot.XYPlot ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class XYLineAndShapeChartPanel6 extends JPanel {

  private ChartOrientation vertical = ChartOrientation.VERTICAL ;

  private IMatrixDataset dataset = createDataset1() ;

  public XYLineAndShapeChartPanel6() {
//    setLayout(new GridLayout(1, 1)) ;
//    addPanel1() ;

    setLayout(new GridLayout(2, 2)) ;
    addPanel1() ;
    addPanel2() ;
    addPanel3() ;
    addPanel4() ;
  }

  private void addPanel1() {

    IJChart chart = ChartFactory.createXYLineAndShapeChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "y axis text", dataset, vertical, true, true, true, false) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private void addPanel2() {
    IJChart chart = ChartFactory.createXYLineAndShapeChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "y axis text", dataset, vertical, true, true, true, false) ;

    XYPlot plot = (XYPlot) chart.getPlot() ;
    AbstractValueAxis valueAxis = plot.getValueAxis() ;
    valueAxis.setInverted(true) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private void addPanel3() {

    IJChart chart = ChartFactory.createXYLineAndShapeChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "y axis text", dataset, vertical, true, true, true, false) ;

    XYPlot plot = (XYPlot) chart.getPlot() ;
    AbstractValueAxis valueAxis = plot.getDomainAxis() ;
    valueAxis.setInverted(true) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private void addPanel4() {

    IJChart chart = ChartFactory.createXYLineAndShapeChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "y axis text", dataset, vertical, true, true, true, false) ;

    XYPlot plot = (XYPlot) chart.getPlot() ;
    AbstractValueAxis valueAxis = plot.getValueAxis() ;
    valueAxis.setInverted(true) ;
    valueAxis = plot.getDomainAxis() ;
    valueAxis.setInverted(true) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static IMatrixDataset createDataset1() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addRowKey("Heart Rate") ;

    dataset.addRowData() ;
    dataset.addData(0, new XYNumberChartData(getYearMills(1, 10, 2006), 143D)) ;
    dataset.addData(0, new XYNumberChartData(getYearMills(3, 10, 2006), 167D)) ;
    dataset.addData(0, new XYNumberChartData(getYearMills(5, 10, 2006), 189D)) ;
    dataset.addData(0, new XYNumberChartData(getYearMills(8, 10, 2006), 156D)) ;
    dataset.addData(0, new XYNumberChartData(getYearMills(10, 10, 2006), 176D)) ;
    dataset.addData(0, new XYNumberChartData(getYearMills(15, 10, 2006), 183D)) ;
    dataset.addData(0, new XYNumberChartData(getYearMills(18, 10, 2006), 138D)) ;
    dataset.addData(0, new XYNumberChartData(getYearMills(29, 10, 2006), 102D)) ;

    dataset.addRowData() ;
    dataset.addData(1, new XYNumberChartData(getYearMills(2, 10, 2006), 1143D)) ;
    dataset.addData(1, new XYNumberChartData(getYearMills(4, 10, 2006), 1167D)) ;
    dataset.addData(1, new XYNumberChartData(getYearMills(5, 10, 2006), 1189D)) ;
    dataset.addData(1, new XYNumberChartData(getYearMills(7, 10, 2006), 156D)) ;
    dataset.addData(1, new XYNumberChartData(getYearMills(9, 10, 2006), 1176D)) ;
    dataset.addData(1, new XYNumberChartData(getYearMills(14, 10, 2006), 1183D)) ;
    dataset.addData(1, new XYNumberChartData(getYearMills(18, 10, 2006), 1138D)) ;
    dataset.addData(1, new XYNumberChartData(getYearMills(28, 10, 2006), 102D)) ;

    return dataset ;
  }

  private static double getYearMills(int day, int month, int year) {
    Date date = new Date(year - 1900, month - 1, day) ;

    return date.getTime() ;
  }

}
