package demo.stackedbarcharts ;

import java.awt.GridLayout ;

import javax.swing.JPanel ;

import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.data.NumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class PopulationChartDemo1 extends JPanel {
  private ChartOrientation orientation = ChartOrientation.HORIZONTAL ;

  public PopulationChartDemo1() {
    setLayout(new GridLayout(1, 1)) ;
    addPanel1() ;
  }

  private void addPanel1() {
    IMatrixDataset dataset = createDataset1() ;
    IJChart chart = ChartFactory.createStackedBarChart("Population Chart Demo 1", "Age Group",
                                                       "Population (millions)", dataset,
                                                       orientation, true, true) ;
    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static IMatrixDataset createDataset1() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addColKey("Male") ;
    dataset.addColKey("Female") ;

    dataset.addRowKey("70+") ;
    dataset.addRowKey("60-69") ;
    dataset.addRowKey("50-59") ;
    dataset.addRowKey("40-49") ;
    dataset.addRowKey("30-39") ;
    dataset.addRowKey("20-29") ;
    dataset.addRowKey("10-19") ;
    dataset.addRowKey("0-9") ;

    double data1[] = { -6D, -8D, -11D, -13D, -14D, -15D, -19D, -21D} ;
    double data2[] = {10D, 12D, 13D, 14D, 15D, 17D, 19D, 20D} ;

    dataset.addRowData(data1.length) ;
    for (int i = 0 ; i < data1.length ; i++) {
      dataset.addData(i, new NumberChartData(data1[i])) ;
      dataset.addData(i, new NumberChartData(data2[i])) ;
    }

    return dataset ;
  }

}
