package demo.statisticalcharts ;

import java.awt.GridLayout ;
import java.util.Random ;

import javax.swing.JPanel ;

import com.ijchart.xychart.axis.value.IntervalXYValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.constant.HistogramType ;
import com.ijchart.xychart.data.IntervalXYNumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.plot.XYPlot ;
import com.ijchart.xychart.tickunit.LongTickUnit ;
import com.ijchart.xychart.util.DatasetUtil ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class HistogramDemo1 extends JPanel {
  private ChartOrientation vertical = ChartOrientation.VERTICAL ;

  public HistogramDemo1() {
    setLayout(new GridLayout(1, 1)) ;
    addPanel1() ;
  }

  private void addPanel1() {
    double ad[] = new double[1000] ;
    Random random = new Random(0xbc614eL) ;
    for (int i = 0 ; i < 1000 ; i++) {
      ad[i] = random.nextGaussian() + 5D ;
    }

    IntervalXYNumberChartData[] datas =
      DatasetUtil.convertToHistogramData(ad, 100, 2D, 8D, HistogramType.FREQUENCY) ;
    ad = new double[1000] ;
    for (int j = 0 ; j < 1000 ; j++) {
      ad[j] = random.nextGaussian() + 7D ;
    }

    IntervalXYNumberChartData[] datas2 =
      DatasetUtil.convertToHistogramData(ad, 100, 4D, 10D, HistogramType.FREQUENCY) ;

    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addRowData(2) ;
    dataset.addRowKey("H1") ;
    dataset.addRowKey("H2") ;
    dataset.addDatas(0, datas) ;
    dataset.addDatas(1, datas2) ;

    IJChart chart = ChartFactory.createHistogramChart("Histogram Demo 1", null, null,
                                                      dataset, vertical, true, true) ;
    XYPlot plot = (XYPlot) chart.getPlot() ;
    IntervalXYValueAxis valueAxis = (IntervalXYValueAxis) plot.getValueAxis() ;
    valueAxis.setTickUnit(new LongTickUnit()) ;
    plot.getDomainAxis().setAxisRangeIncludeZero(false) ;
    plot.getDomainAxis().setLowerMargin(0.02) ;
    plot.getDomainAxis().setUpperMargin(0.02) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

}
