package demo.statisticalcharts ;

import java.awt.GridLayout ;

import javax.swing.JPanel ;

import com.ijchart.xychart.axis.value.IntervalXYValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.data.IntervalXYNumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.plot.XYPlot ;
import com.ijchart.xychart.tickunit.LongTickUnit ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class HistogramDemo2 extends JPanel {
  private ChartOrientation vertical = ChartOrientation.VERTICAL ;

  public HistogramDemo2() {
    setLayout(new GridLayout(1, 1)) ;
    addPanel1() ;
  }

  private void addPanel1() {
    IntervalXYNumberChartData[] datas = new IntervalXYNumberChartData[4] ;
    datas[0] = new IntervalXYNumberChartData(0, 1, 0, 1) ;
    datas[1] = new IntervalXYNumberChartData(1, 2, 0, 10) ;
    datas[2] = new IntervalXYNumberChartData(2, 3, 0, 15) ;
    datas[3] = new IntervalXYNumberChartData(3, 4, 0, 20) ;

    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addRowData() ;
    dataset.addRowKey("Series 1") ;
    dataset.addDatas(0, datas) ;

    IJChart chart = ChartFactory.createHistogramChart("Histogram Demo 2", null, null,
                                                      dataset, vertical, true, true) ;
    XYPlot plot = (XYPlot) chart.getPlot() ;
    IntervalXYValueAxis valueAxis = (IntervalXYValueAxis) plot.getValueAxis() ;
    valueAxis.setTickUnit(new LongTickUnit()) ;
    plot.getDomainAxis().setUpperMargin(0.05) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

}
