package demo.xycharts ;

import java.awt.BorderLayout ;

import javax.swing.JPanel ;

import com.ijchart.xychart.axis.value.XYNumberValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.data.VectorChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.plot.XYPlot ;
import com.ijchart.xychart.tickunit.LongTickUnit ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class VectorDemo1 extends JPanel {

  public VectorDemo1() {
    setLayout(new BorderLayout()) ;
    createPanel1() ;
  }

  private void createPanel1() {
    IJChart chart = ChartFactory.createVectorChart(
      "Vector Plot Demo 1", "X", "Y", createDataset(), ChartOrientation.VERTICAL,
      true, true, false, false) ;

    XYPlot plot = (XYPlot) chart.getPlot() ;
    XYNumberValueAxis xAxis = (XYNumberValueAxis) plot.getDomainAxis() ;
    xAxis.setAxisRangeIncludeZero(false) ;
    xAxis.setLowerMargin(0.01) ;
    xAxis.setUpperMargin(0.01) ;
    xAxis.setTickUnit(new LongTickUnit()) ;

    XYNumberValueAxis yAxis = (XYNumberValueAxis) plot.getValueAxis() ;
    yAxis.setAxisRangeIncludeZero(false) ;
    yAxis.setLowerMargin(0.01) ;
    yAxis.setUpperMargin(0.01) ;
    yAxis.setTickUnit(new LongTickUnit()) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static IMatrixDataset createDataset() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;

    dataset.addRowData() ;
    dataset.addRowKey("Series 1") ;

    for (double d = 0.0D ; d < 20D ; d++) {
      for (double d1 = 0.0D ; d1 < 20D ; d1++) {
        VectorChartData data = new VectorChartData(d + 10D, d1 + 10D, Math.sin(d / 5D) / 2D,
                                                   Math.cos(d1 / 5D) / 2D) ;
        dataset.addData(0, data) ;
      }
    }

    return dataset ;
  }

}
