package demo.xycharts;

import java.awt.Color ;
import java.awt.Font ;
import java.awt.GridLayout ;

import javax.swing.JPanel ;

import com.ijchart.xychart.axis.value.NumberValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.constant.HorizontalAlignment ;
import com.ijchart.xychart.constant.VerticalAlignment ;
import com.ijchart.xychart.data.IntervalXYNumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.marker.IntervalValueMarker ;
import com.ijchart.xychart.plot.XYPlot ;
import com.ijchart.xychart.ui.Layer ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class XYSeriesDemo3 extends JPanel {

  public XYSeriesDemo3() {
    setLayout(new GridLayout(1, 1)) ;
    createPanel1() ;
  }

  public void createPanel1() {
    IJChart chart = ChartFactory.createIntervalXYBar2DChart(
      "XY Series Demo 3", "X", "Y", createDataset(), ChartOrientation.VERTICAL,
      true, true, false, false) ;

    XYPlot plot = (XYPlot) chart.getPlot() ;
    NumberValueAxis numberaxis = (NumberValueAxis) plot.getValueAxis() ;

    IntervalValueMarker intervalMarker = new IntervalValueMarker(400D, 700D) ;
    intervalMarker.setText("Target Range") ;
    intervalMarker.setTextFont(new Font("SansSerif", 2, 11)) ;
    intervalMarker.setTextHorizontalAlign(HorizontalAlignment.LEFT) ;
    intervalMarker.setTextVerticalAlign(VerticalAlignment.CENTER) ;
    intervalMarker.setFillPaint(new Color(222, 222, 255, 128)) ;

    numberaxis.addIntervalValueMarker(Layer.BACKGROUND, intervalMarker) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static IMatrixDataset createDataset() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;

    dataset.addRowData() ;
    dataset.addRowKey("Random Data") ;

    dataset.addData(0, new IntervalXYNumberChartData(1.0D, 2.0, 0, 400.19999999999999D)) ;
    dataset.addData(0, new IntervalXYNumberChartData(5D, 6, 0, 294.10000000000002D)) ;
    dataset.addData(0, new IntervalXYNumberChartData(4D, 5, 0, 100D)) ;
    dataset.addData(0, new IntervalXYNumberChartData(12.5D, 13.5, 0, 734.39999999999998D)) ;
    dataset.addData(0,
                    new IntervalXYNumberChartData(17.300000000000001D, 18.3, 0, 453.19999999999999D)) ;
    dataset.addData(0,
                    new IntervalXYNumberChartData(21.199999999999999D, 22.2, 0, 500.19999999999999D)) ;
    dataset.addData(0, new IntervalXYNumberChartData(21.899999999999999D, 22.89, 0, Double.NaN)) ;
    dataset.addData(0,
                    new IntervalXYNumberChartData(25.600000000000001D, 26.6, 0, 734.39999999999998D)) ;
    dataset.addData(0, new IntervalXYNumberChartData(30D, 31, 0, 453.19999999999999D)) ;

    return dataset ;
  }

}
