package com.ijchart.xychart.constant ;

import java.io.Serializable ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 * <zh>(area)͵ͼһĻƷ.</zh>
 * <en>Describe the type of draw last point for area chart.</en>
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public final class AreaRenderEndType implements Serializable {
  /**
   * <zh>л汾ID.</zh>
   * <en>For serialization.</en>
   */
  private static final long serialVersionUID = 7280134056460725185L ;

  /**
   * <zh>һһֵƵ.</zh>
   * <en>The area tapers from the first or last value down to base value.</en>
   */
  public static final AreaRenderEndType TAPER = new AreaRenderEndType("AreaRenderEndType.TAPER") ;

  /**
   * <zh>һһֵض.</zh>
   * <en>The area is truncated at the first or last value.</en>
   */
  public static final AreaRenderEndType TRUNCATE = new AreaRenderEndType(
    "AreaRenderEndType.TRUNCATE") ;


  /**
   * <zh>.</zh>
   * <en>The name.</en>
   */
  private String name ;

  /**
   * <zh>˽йֹʵ.</zh>
   * <en>Private constructor to prevent instance.</en>
   *
   * @param name <zh>.</zh>
   * <en>The name.</en>
   */
  private AreaRenderEndType(String name) {
    this.name = name ;
  }

  /**
   * <zh>hashcodeֵ.</zh>
   * <en>Returns a hash code value for the object.</en>
   *
   * @return <zh>hashcodeֵ.</zh>
   * <en>The hashcode.</en>
   */
  public int hashCode() {
    return this.name.hashCode() ;
  }

  /**
   * <zh>Ƿ,ȷtrue,򷵻false.</zh>
   * <en>Returns true if this object is equal to the specified object, and false otherwise.</en>
   *
   * @param obj <zh>ҪȽϵĶ (Ϊnull)</zh>
   * <en>The object (null permitted).</en>
   *
   * @return A boolean.
   */
  public boolean equals(Object obj) {
    if (this == obj) {
      return true ;
    }
    if (!(obj instanceof AreaRenderEndType)) {
      return false ;
    }

    AreaRenderEndType that = (AreaRenderEndType) obj ;
    if (!this.name.equals(that.name)) {
      return false ;
    }

    return true ;
  }

  /**
   * <zh>toString.</zh>
   * <en>Returns a string representing the object.</en>
   *
   * @return The string.
   */
  public String toString() {
    return this.name ;
  }

}
