package com.ijchart.xychart.constant ;

import java.io.Serializable ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 * <zh>ַĶ뷽ʽ.</zh>
 * <en>Used to indicate the position of a text.</en>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public final class TextAnchor implements Serializable {
  /**
   * <zh>л汾ID.</zh>
   * <en>For serialization.</en>
   */
  private static final long serialVersionUID = 5426478000639027961L ;

  /**
   * <zh>ʼλ.</zh>
   * <en>The start position.</en>
   */
  public static final TextAnchor START = new TextAnchor("TextAnchor.START") ;

  /**
   * <zh>мλ.</zh>
   * <en>The middle position.</en>
   */
  public static final TextAnchor MIDDLE = new TextAnchor("TextAnchor.MIDDLE") ;

  /**
   * <zh>λ.</zh>
   * <en>The end position.</en>
   */
  public static final TextAnchor END = new TextAnchor("TextAnchor.END") ;

  /**
   * <zh>.</zh>
   * <en>The name.</en>
   */
  private String name ;

  /**
   * <zh>˽йֹʵ.</zh>
   * <en>Private constructor to prevent instance.</en>
   *
   * @param name <zh>.</zh>
   * <en>The name.</en>
   */
  private TextAnchor(String name) {
    this.name = name ;
  }

  /**
   * <zh></zh>
   * <en>Returns a string representing the object.</en>
   * @return The string.
   */
  public String toString() {
    return this.name ;
  }

  /**
   * <zh>Ƿ.</zh>
   * <en>Returns true if this object is equal to the specified object, and false otherwise.</en>
   *
   * @param o  the other object.
   * @return A boolean.
   */
  public boolean equals(Object o) {
    if (this == o) {
      return true ;
    }
    if (!(o instanceof TextAnchor)) {
      return false ;
    }

    TextAnchor anchor = (TextAnchor) o ;
    if (!this.name.equals(anchor.name)) {
      return false ;
    }

    return true ;
  }

  /**
   * <zh>hashcodeֵ.</zh>
   * <en>Returns a hash code value for the object</en>
   *
   * @return int <zh>hashcodeֵ.</zh>
   * <en>A hash code value for this object.</en>
   */
  public int hashCode() {
    return name.hashCode() ;
  }

}
