package com.ijchart.xychart.event ;

import java.io.Serializable ;
import java.util.EventObject ;

import com.ijchart.xychart.axis.IAxis ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 * <zh>ᷢ仯¼.</zh>
 * <en>A change event that encapsulates information about a change to an axis.</en>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class AxisChangeEvent extends EventObject implements Serializable {
  /**
   * <zh>л汾ID.</zh>
   * <en>For serialization.</en>
   */
  private static final long serialVersionUID = 7910425775652970925L ;

  /**
   * <zh>¼.</zh>
   * <en>The axis that generated the change event.</en>
   */
  private IAxis axis ;

  /**
   * <zh>һµĶ.</zh>
   * <en>Creates a new instance.</en>
   *
   * @param axis IAxis <zh>¼ (Ϊnull).</zh>
   * <en>The axis that generated the event (null not permitted).</en>
   */
  public AxisChangeEvent(IAxis axis) {
    super(axis) ;
    this.axis = axis ;
  }

  /**
   * <zh>ز¼.</zh>
   * <en>Returns the axis that generated the event.</en>
   *
   * @return <zh>¼</zh>
   * <en>The axis that generated the event.</en>
   */
  public IAxis getAxis() {
    return this.axis ;
  }

}
