package com.ijchart.xychart.ui ;

import java.io.Serializable ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 * <zh>ڱ־ǰǱĳ.</zh>
 * <en>Used to indicate either the foreground or background layer.</en>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public final class Layer implements Serializable {
  /**
   * <zh>л汾ID.</zh>
   * <en>For serialization.</en>
   */
  private static final long serialVersionUID = -4139595800452825721L ;

  /**
   * <zh>ǰ.</zh>
   * <en>Foreground.</en>
   */
  public static final Layer FOREGROUND = new Layer("Layer.FOREGROUND") ;

  /**
   * <zh>.</zh>
   * <en>Background.</en>
   */
  public static final Layer BACKGROUND = new Layer("Layer.BACKGROUND") ;

  /**
   * <zh>.</zh>
   * <en>The name.</en>
   */
  private String name ;

  /**
   * <zh>˽йֹʵ.</zh>
   * <en>Private constructor to prevent instance.</en>
   */
  private Layer(final String name) {
    this.name = name ;
  }

  /**
   * <zh>toString.</zh>
   * <en>Returns a string representing the object.</en>
   *
   * @return String <zh>.</zh>
   * <en>The name.</en>
   */
  public String toString() {
    return this.name ;
  }

  /**
   * <zh>Ƿ.</zh>
   * <en>Returns true if this object is equal to the specified
   * object, and false otherwise.</en>
   *
   * @param o The other object.
   *
   * @return A boolean.
   */
  public boolean equals(final Object o) {
    if (this == o) {
      return true ;
    }
    if (!(o instanceof Layer)) {
      return false ;
    }

    Layer layer = (Layer) o ;
    if (!this.name.equals(layer.name)) {
      return false ;
    }

    return true ;
  }

  /**
   * <zh>hashcode.</zh>
   * <en>Returns a hash code value for the object.</en>
   *
   * @return int the hashcode
   */
  public int hashCode() {
    return this.name.hashCode() ;
  }
}
